//=====================================================================
//
//	`$INSTANCE_NAME`.h - j1sys fs component
//
//	version 1.0 - 8 sep 2014
//
//=====================================================================

#if !defined(`$INSTANCE_NAME`_H)
#define `$INSTANCE_NAME`_H
	
#include <j1Types.h>

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

//---------------------------------------------------------------------
//	`$j1LIB_NAME`_CTRL
//---------------------------------------------------------------------
	
typedef struct _`$j1LIB_NAME`_CTRL
{
	bool	(*readArray)(void *deviceCtrl, uint32 startAddr, uint8 *readBfr, uint16 readCnt);
	void	*deviceCtrl;
	uint32	deviceOffset;
	uint8	bytesPerBlock;
	uint16	rootStart;
	uint16	rootSize;
	
} `$j1LIB_NAME`_CTRL;

//---------------------------------------------------------------------
//	`$j1LIB_NAME`_FCB
//---------------------------------------------------------------------

typedef struct _`$j1LIB_NAME`_FCB
{
	`$j1LIB_NAME`_CTRL	*j1FS_Ctrl;
	uint32			fileStartAddr;
	uint16			fileSize;
	uint16			currReadAddr;
	
} `$j1LIB_NAME`_FCB;

//---------------------------------------------------------------------
//	`$j1LIB_NAME`_DIR_ENTRY
//---------------------------------------------------------------------

typedef struct __attribute__ ((__packed__)) _`$j1LIB_NAME`_DIR_ENTRY
{
	uint8	nameExt[11];	// name and ext field
	uint8	attrib;			// attributes byte
	uint16	startBlock;		// start block
	uint16	fileSize;		// file size in bytes
	
} `$j1LIB_NAME`_DIR_ENTRY;

#define	`$j1LIB_NAME`_DIR_ATTRIB_DIRECTORY	0x80


//---------------------------------------------------------------------
//	function prototypes
//---------------------------------------------------------------------

bool	`$j1LIB_NAME`_Start				(`$j1LIB_NAME`_CTRL *j1FS_Ctrl, bool (*readArray)(void *deviceCtrl, uint32 startAddr, uint8 *readBfr, uint16 readCnt), void *deviceCtrl, uint32 deviceOffset);
bool	`$j1LIB_NAME`_GetVolumeID		(`$j1LIB_NAME`_CTRL *j1FS_Ctrl, char *volumeIDBfr, uint8 bfrLen);

bool	`$j1LIB_NAME`_OpenFile			(`$j1LIB_NAME`_CTRL *j1FS_Ctrl, char *fileSpec, `$j1LIB_NAME`_FCB *fcb);
bool	`$j1LIB_NAME`_SeekFile			(`$j1LIB_NAME`_FCB *fcb, uint16 readAddr);
bool	`$j1LIB_NAME`_ReadFile			(`$j1LIB_NAME`_FCB *fcb, uint8 *bfrPtr, uint16 bfrSiz, uint16 *bfrRead);
bool	`$j1LIB_NAME`_RewindFile		(`$j1LIB_NAME`_FCB *fcb);

uint16	`$j1LIB_NAME`_Remaining			(`$j1LIB_NAME`_FCB *fcb);

bool	`$j1LIB_NAME`_ReadDeviceArray	(`$j1LIB_NAME`_CTRL *j1FS_Ctrl, uint32 readAddress, uint8 *readBfr, uint16 readCnt);
bool	`$j1LIB_NAME`_NameToString		(bool volName, `$j1LIB_NAME`_DIR_ENTRY *dirEntry, char *nameStringBfr, uint8 nameStringBfrLen);

#endif	// `$INSTANCE_NAME`_H
