//=====================================================================
//
//	`$INSTANCE_NAME`.h - `$INSTANCE_NAME` h file
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#if !defined(`$INSTANCE_NAME`_H)
#define `$INSTANCE_NAME`_H

#define	`$INSTANCE_NAME`_PARAM_J1GFX_INSTANCE	`$J1GFX_INSTANCE`
#define	`$INSTANCE_NAME`_PARAM_J1GFX_LIB		`$J1GFX_LIB`
#define	`$INSTANCE_NAME`_PARAM_LCD_PAR_MODE		`$LCD_PAR_MODE`
#define	`$INSTANCE_NAME`_PARAM_LCD_SPI_MODE		`$LCD_SPI_MODE`
#define	`$INSTANCE_NAME`_PARAM_SENDER			`$SENDER`
#define	`$INSTANCE_NAME`_PARAM_RECEIVER			`$RECEIVER`
#define	`$INSTANCE_NAME`_PARAM_TOUCH_SPI_ENABLE	`$TOUCH_SPI_ENABLE`
#define	`$INSTANCE_NAME`_PARAM_TOUCH_SPI_SHARED	`$TOUCH_SPI_SHARED`
#define	`$INSTANCE_NAME`_PARAM_TOUCH_UP_PRE_CNT	`$TOUCH_UP_PRE_CNT`
#define	`$INSTANCE_NAME`_PARAM_TOUCH_UP_PST_CNT	`$TOUCH_UP_PST_CNT`
#define	`$INSTANCE_NAME`_PARAM_TOUCH_DELTA_MAX	`$TOUCH_DELTA_MAX`
	
#include "`$J1GFX_INSTANCE`.h"
#include "`$INSTANCE_NAME`_LCD.hh"
#include "`$INSTANCE_NAME`_Touch.hh"

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD hardware ctrl
//---------------------------------------------------------------------

typedef struct _`$INSTANCE_NAME`_CTRL
{
	`$J1GFX_LIB`_HOOKS			hooks;

	`$J1GFX_LIB`_ROTATE			currRotation;		// current rotation
	uint16						currWidth;			// current width
	uint16						currHeight;			// current height
	
	`$INSTANCE_NAME`_LCD_CTRL	LCD_Ctrl;
#if `$INSTANCE_NAME`_PARAM_TOUCH_SPI_ENABLE
	`$INSTANCE_NAME`_Touch_CTRL	Touch_Ctrl;
#endif
	
} `$INSTANCE_NAME`_CTRL;

bool `$INSTANCE_NAME`_Start(`$INSTANCE_NAME`_CTRL *HY28B_Ctrl, `$J1GFX_LIB`_CTRL *j1GFX_Ctrl, uint8 displayType, uint8 rotate, uint32 rgb, `$INSTANCE_NAME`_Touch_CTRL *preload);

#endif	// `$INSTANCE_NAME`_H
