//=====================================================================
//
//	`$INSTANCE_NAME`_LCD.c - HAOYU 2.8" GFX Driver
//
//	version 1.1 - 15 feb 2014
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#include <project.h>
//#include "`$INSTANCE_NAME`_LCD.h"

//#define	HY28B_PAR_MODE		1
//#define	HY28B_SPI_MODE		0

//#define BITBAND_PERI_REF   0x40000000
//#define BITBAND_PERI_BASE  0x42000000
//#define BITBAND_PERI(a,b) ((BITBAND_PERI_BASE + (a-BITBAND_PERI_REF)*32 + (b*4)))  // Convert PERI address

//#define HY28B_CTRL_WR_BB  *((volatile unsigned char *) (BITBAND_PERI(&HY28B_Bus_DR,6)))   // Bit 6

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_ResetHi()/Lo()
//---------------------------------------------------------------------

#define	`$INSTANCE_NAME`_LCD_ResetHi()	*`$INSTANCE_NAME`_iCtrl_Control_PTR |= `$INSTANCE_NAME`_CTRL_RESET
#define	`$INSTANCE_NAME`_LCD_ResetLo()	*`$INSTANCE_NAME`_iCtrl_Control_PTR &= ~`$INSTANCE_NAME`_CTRL_RESET

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_SelectHi()/Lo()
//---------------------------------------------------------------------

#define	`$INSTANCE_NAME`_LCD_SelectHi()	*`$INSTANCE_NAME`_iCtrl_Control_PTR |= `$INSTANCE_NAME`_CTRL_SS
#define	`$INSTANCE_NAME`_LCD_SelectLo()	*`$INSTANCE_NAME`_iCtrl_Control_PTR &= ~`$INSTANCE_NAME`_CTRL_SS

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_RS_Hi()/Lo()
//---------------------------------------------------------------------

#define	`$INSTANCE_NAME`_LCD_RS_Hi()	*`$INSTANCE_NAME`_iCtrl_Control_PTR |= `$INSTANCE_NAME`_CTRL_RS
#define	`$INSTANCE_NAME`_LCD_RS_Lo()	*`$INSTANCE_NAME`_iCtrl_Control_PTR &= ~`$INSTANCE_NAME`_CTRL_RS

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_RD_Hi()/Lo()
//---------------------------------------------------------------------

#define	`$INSTANCE_NAME`_LCD_RD_Hi()	*`$INSTANCE_NAME`_iCtrl_Control_PTR |= `$INSTANCE_NAME`_CTRL_RD
#define	`$INSTANCE_NAME`_LCD_RD_Lo()	*`$INSTANCE_NAME`_iCtrl_Control_PTR &= ~`$INSTANCE_NAME`_CTRL_RD

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_WR_Hi()/Lo()
//---------------------------------------------------------------------

#define	`$INSTANCE_NAME`_LCD_WR_Hi()	*`$INSTANCE_NAME`_iCtrl_Control_PTR |= `$INSTANCE_NAME`_CTRL_WR
#define	`$INSTANCE_NAME`_LCD_WR_Lo()	*`$INSTANCE_NAME`_iCtrl_Control_PTR &= ~`$INSTANCE_NAME`_CTRL_WR

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_SpiWrite()
//---------------------------------------------------------------------

#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
inline void `$INSTANCE_NAME`_LCD_SpiWrite(uint8 val)
{
	while((`$INSTANCE_NAME`_iLSPI_TX_STATUS_REG & `$INSTANCE_NAME`_iLSPI_STS_TX_FIFO_NOT_FULL) == 0) {}
    *`$INSTANCE_NAME`_iLSPI_TXDATA_PTR = val;
}
#endif

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_SpiWait()
//---------------------------------------------------------------------

#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
inline void `$INSTANCE_NAME`_LCD_SpiWait()
{
	while ((`$INSTANCE_NAME`_iLSPI_TX_STATUS_REG & `$INSTANCE_NAME`_iLSPI_STS_SPI_DONE) == 0) {}
}
#endif

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_SpiWriteRead()
//---------------------------------------------------------------------

#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
inline uint8 `$INSTANCE_NAME`_LCD_SpiWriteRead(uint8 val)
{
    *`$INSTANCE_NAME`_iLSPI_TXDATA_PTR = val;
	while ((`$INSTANCE_NAME`_iLSPI_TX_STATUS_REG & `$INSTANCE_NAME`_iLSPI_STS_SPI_DONE) == 0) {}
	return *`$INSTANCE_NAME`_iLSPI_RXDATA_PTR;
}
#endif

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_Color565()
//---------------------------------------------------------------------

uint16 `$INSTANCE_NAME`_LCD_Color565(uint32 rgb)
{
  return ((rgb & 0xF80000) >> 8) | ((rgb & 0x00FC00) >> 5) | ((rgb & 0x0000F8) >> 3);
}

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_WriteIndex()
//---------------------------------------------------------------------

void `$INSTANCE_NAME`_LCD_WriteIndex(uint8 index)
{
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
	`$INSTANCE_NAME`_LCD_SelectLo();
	`$INSTANCE_NAME`_LCD_SpiWrite(`$INSTANCE_NAME`_LCD_START | `$INSTANCE_NAME`_LCD_WR | `$INSTANCE_NAME`_LCD_INDEX);
	`$INSTANCE_NAME`_LCD_SpiWrite(0);
	`$INSTANCE_NAME`_LCD_SpiWrite(index);
	`$INSTANCE_NAME`_LCD_SpiWait();
	`$INSTANCE_NAME`_LCD_SelectHi();
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
	`$INSTANCE_NAME`_LCD_SelectLo();
	`$INSTANCE_NAME`_LCD_RS_Lo();
	`$INSTANCE_NAME`_iLBus_Write(0);
	`$INSTANCE_NAME`_LCD_WR_Lo();
	`$INSTANCE_NAME`_LCD_WR_Hi();
	`$INSTANCE_NAME`_iLBus_Write(index);
	`$INSTANCE_NAME`_LCD_WR_Lo();
	`$INSTANCE_NAME`_LCD_WR_Hi();
	`$INSTANCE_NAME`_LCD_RS_Hi();
	`$INSTANCE_NAME`_LCD_SelectHi();
#endif
}

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_WriteData()
//---------------------------------------------------------------------

void `$INSTANCE_NAME`_LCD_WriteData(uint16 val)
{
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
	`$INSTANCE_NAME`_LCD_SelectLo();
	`$INSTANCE_NAME`_LCD_SpiWrite(`$INSTANCE_NAME`_LCD_START | `$INSTANCE_NAME`_LCD_WR | `$INSTANCE_NAME`_LCD_DATA);
	`$INSTANCE_NAME`_LCD_SpiWrite(val >> 8);
	`$INSTANCE_NAME`_LCD_SpiWrite(val & 0x00ff);
	`$INSTANCE_NAME`_LCD_SpiWait();
	`$INSTANCE_NAME`_LCD_SelectHi();
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
	`$INSTANCE_NAME`_LCD_SelectLo();
	`$INSTANCE_NAME`_iLBus_Write(val >> 8);
	`$INSTANCE_NAME`_LCD_WR_Lo();
	`$INSTANCE_NAME`_LCD_WR_Hi();
	`$INSTANCE_NAME`_iLBus_Write(val & 0x00ff);
	`$INSTANCE_NAME`_LCD_WR_Lo();
	`$INSTANCE_NAME`_LCD_WR_Hi();
	`$INSTANCE_NAME`_LCD_SelectHi();
#endif
}

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_ReadData()
//---------------------------------------------------------------------

uint16 `$INSTANCE_NAME`_LCD_ReadData()
{ 
	uint16	val;

#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
	// flush fifos
	`$INSTANCE_NAME`_iLSPI_ClearRxBuffer();
	`$INSTANCE_NAME`_LCD_SelectLo();
	`$INSTANCE_NAME`_LCD_SpiWriteRead(`$INSTANCE_NAME`_LCD_START | `$INSTANCE_NAME`_LCD_RD | `$INSTANCE_NAME`_LCD_DATA);
	`$INSTANCE_NAME`_LCD_SpiWriteRead(0);
	val  = `$INSTANCE_NAME`_LCD_SpiWriteRead(0) << 8;
	val |= `$INSTANCE_NAME`_LCD_SpiWriteRead(0);
	`$INSTANCE_NAME`_LCD_SelectHi();
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
	`$INSTANCE_NAME`_iLBus_SetDriveMode(`$INSTANCE_NAME`_iLBus_DM_DIG_HIZ);
	`$INSTANCE_NAME`_LCD_SelectLo();
	`$INSTANCE_NAME`_LCD_RD_Lo();
	val  = `$INSTANCE_NAME`_iLBus_Read() << 8;
	`$INSTANCE_NAME`_LCD_RD_Hi();
	`$INSTANCE_NAME`_LCD_RD_Lo();
	val |= `$INSTANCE_NAME`_iLBus_Read();
	`$INSTANCE_NAME`_LCD_RD_Hi();
	`$INSTANCE_NAME`_LCD_SelectHi();
	`$INSTANCE_NAME`_iLBus_SetDriveMode(`$INSTANCE_NAME`_iLBus_DM_STRONG);
#endif

	return val;
}

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_WriteReg()
//---------------------------------------------------------------------

void `$INSTANCE_NAME`_LCD_WriteReg(uint16 regNum, uint16 val)
{
	/* Write 16-bit Index, then Write Reg */  
	`$INSTANCE_NAME`_LCD_WriteIndex(regNum);         
	/* Write 16-bit Reg */
	`$INSTANCE_NAME`_LCD_WriteData(val);  
}

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_ReadReg()
//---------------------------------------------------------------------

uint16 `$INSTANCE_NAME`_LCD_ReadReg(uint16 regNum)
{
	/* Write 16-bit Index (then Read Reg) */
	`$INSTANCE_NAME`_LCD_WriteIndex(regNum);
	/* Read 16-bit Reg */
	return `$INSTANCE_NAME`_LCD_ReadData();
}

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_Init() - init the display hardware
//---------------------------------------------------------------------

void `$INSTANCE_NAME`_LCD_Init(`$J1GFX_LIB`_CTRL *j1GFX_Ctrl, uint8 dispType)
{
	uint16	deviceCode;
	
	`$INSTANCE_NAME`_LCD_DelayMS(100);		// give power up a chance
	`$INSTANCE_NAME`_LCD_ResetLo();			// drive reset lo
	`$INSTANCE_NAME`_LCD_DelayMS(100);		// stay lo for 100ms
	`$INSTANCE_NAME`_LCD_ResetHi();			// bring high
	`$INSTANCE_NAME`_LCD_DelayMS(100);		// and give it time
	
	deviceCode = `$INSTANCE_NAME`_LCD_ReadReg(0x00);		/* Read ID	*/
	
	switch (deviceCode)
	{
	case 0x9325:
	case 0x9328:
		`$INSTANCE_NAME`_LCD_WriteReg(0xe7,0x0010);      
		`$INSTANCE_NAME`_LCD_WriteReg(0x00,0x0001);  	/* start internal osc */
		`$INSTANCE_NAME`_LCD_WriteReg(0x01,0x0100);     
		`$INSTANCE_NAME`_LCD_WriteReg(0x02,0x0700); 	/* power on sequence */
//		`$INSTANCE_NAME`_LCD_WriteReg(0x03,(1<<12)|(1<<5)|(1<<4)|(0<<3) ); 	/* importance */
		`$INSTANCE_NAME`_LCD_WriteReg(0x03, `$INSTANCE_NAME`_LCD_EM_03_BGR | `$INSTANCE_NAME`_LCD_EM_03_ID0 | `$INSTANCE_NAME`_LCD_EM_03_AM);
		`$INSTANCE_NAME`_LCD_WriteReg(0x04,0x0000);                                   
		`$INSTANCE_NAME`_LCD_WriteReg(0x08,0x0207);	           
		`$INSTANCE_NAME`_LCD_WriteReg(0x09,0x0000);         
		`$INSTANCE_NAME`_LCD_WriteReg(0x0a,0x0000); 	/* display setting */        
		`$INSTANCE_NAME`_LCD_WriteReg(0x0c,0x0001);	/* display setting */        
		`$INSTANCE_NAME`_LCD_WriteReg(0x0d,0x0000); 			        
		`$INSTANCE_NAME`_LCD_WriteReg(0x0f,0x0000);
		/* Power On sequence */
		`$INSTANCE_NAME`_LCD_WriteReg(0x10,0x0000);   
		`$INSTANCE_NAME`_LCD_WriteReg(0x11,0x0007);
		`$INSTANCE_NAME`_LCD_WriteReg(0x12,0x0000);                                                                 
		`$INSTANCE_NAME`_LCD_WriteReg(0x13,0x0000);                 
		`$INSTANCE_NAME`_LCD_DelayMS(50);  /* delay 50 ms */		
		`$INSTANCE_NAME`_LCD_WriteReg(0x10,0x1590);   
		`$INSTANCE_NAME`_LCD_WriteReg(0x11,0x0227);
		`$INSTANCE_NAME`_LCD_DelayMS(50);  /* delay 50 ms */		
		`$INSTANCE_NAME`_LCD_WriteReg(0x12,0x009c);                  
		`$INSTANCE_NAME`_LCD_DelayMS(50);  /* delay 50 ms */		
		`$INSTANCE_NAME`_LCD_WriteReg(0x13,0x1900);   
		`$INSTANCE_NAME`_LCD_WriteReg(0x29,0x0023);
		`$INSTANCE_NAME`_LCD_WriteReg(0x2b,0x000e);
		`$INSTANCE_NAME`_LCD_DelayMS(50);  /* delay 50 ms */		
		`$INSTANCE_NAME`_LCD_WriteReg(0x20,0x0000);                                                            
		`$INSTANCE_NAME`_LCD_WriteReg(0x21,0x0000);           
		`$INSTANCE_NAME`_LCD_DelayMS(50);  /* delay 50 ms */		
		`$INSTANCE_NAME`_LCD_WriteReg(0x30,0x0007); 
		`$INSTANCE_NAME`_LCD_WriteReg(0x31,0x0707);   
		`$INSTANCE_NAME`_LCD_WriteReg(0x32,0x0006);
		`$INSTANCE_NAME`_LCD_WriteReg(0x35,0x0704);
		`$INSTANCE_NAME`_LCD_WriteReg(0x36,0x1f04); 
		`$INSTANCE_NAME`_LCD_WriteReg(0x37,0x0004);
		`$INSTANCE_NAME`_LCD_WriteReg(0x38,0x0000);        
		`$INSTANCE_NAME`_LCD_WriteReg(0x39,0x0706);     
		`$INSTANCE_NAME`_LCD_WriteReg(0x3c,0x0701);
		`$INSTANCE_NAME`_LCD_WriteReg(0x3d,0x000f);
		`$INSTANCE_NAME`_LCD_DelayMS(50);  /* delay 50 ms */		
		`$INSTANCE_NAME`_LCD_WriteReg(0x50,0x0000);        
		`$INSTANCE_NAME`_LCD_WriteReg(0x51,0x00ef);   
		`$INSTANCE_NAME`_LCD_WriteReg(0x52,0x0000);     
		`$INSTANCE_NAME`_LCD_WriteReg(0x53,0x013f);
		`$INSTANCE_NAME`_LCD_WriteReg(0x60,0xa700);        
		`$INSTANCE_NAME`_LCD_WriteReg(0x61,0x0001); 
		`$INSTANCE_NAME`_LCD_WriteReg(0x6a,0x0000);
		`$INSTANCE_NAME`_LCD_WriteReg(0x80,0x0000);
		`$INSTANCE_NAME`_LCD_WriteReg(0x81,0x0000);
		`$INSTANCE_NAME`_LCD_WriteReg(0x82,0x0000);
		`$INSTANCE_NAME`_LCD_WriteReg(0x83,0x0000);
		`$INSTANCE_NAME`_LCD_WriteReg(0x84,0x0000);
		`$INSTANCE_NAME`_LCD_WriteReg(0x85,0x0000);
		  
		`$INSTANCE_NAME`_LCD_WriteReg(0x90,0x0010);     
		`$INSTANCE_NAME`_LCD_WriteReg(0x92,0x0000);  
		`$INSTANCE_NAME`_LCD_WriteReg(0x93,0x0003);
		`$INSTANCE_NAME`_LCD_WriteReg(0x95,0x0110);
		`$INSTANCE_NAME`_LCD_WriteReg(0x97,0x0000);        
		`$INSTANCE_NAME`_LCD_WriteReg(0x98,0x0000);  
		/* display on sequence */    
		`$INSTANCE_NAME`_LCD_WriteReg(0x07,0x0133);
		
		`$INSTANCE_NAME`_LCD_WriteReg(0x20,0x0000);         
		`$INSTANCE_NAME`_LCD_WriteReg(0x21,0x0000);
		break;
	}
	
    `$INSTANCE_NAME`_LCD_DelayMS(100);   /* delay 100 ms */		
}

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_StartHelper() - init and setup the LCD interface
//---------------------------------------------------------------------

bool `$INSTANCE_NAME`_LCD_StartHelper(`$J1GFX_LIB`_CTRL *j1GFX_Ctrl, uint8 dispType, uint8 rotate, uint32_t rgb)
{
	`$INSTANCE_NAME`_CTRL	*hCtrl;
	
#if `$INSTANCE_NAME`_PARAM_SENDER
	cmds.LCD_Start.cmd		= CMD_LCD_START;
	cmds.LCD_Start.dispType	= dispType;
	cmds.LCD_Start.rotate	= rotate;
	cmds.LCD_Start.rgb		= rgb;
	`$INSTANCE_NAME`_Send(&cmds, sizeof(cmds.LCD_Start));
#endif

	hCtrl = j1GFX_Ctrl->hardware;

#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
	*`$INSTANCE_NAME`_iCtrl_Control_PTR = `$INSTANCE_NAME`_CTRL_RESET | `$INSTANCE_NAME`_CTRL_SS;
	`$INSTANCE_NAME`_iLSPI_Start();
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
	*`$INSTANCE_NAME`_iCtrl_Control_PTR	= `$INSTANCE_NAME`_CTRL_RESET | `$INSTANCE_NAME`_CTRL_SS | `$INSTANCE_NAME`_CTRL_RS | `$INSTANCE_NAME`_CTRL_RD | `$INSTANCE_NAME`_CTRL_WR | `$INSTANCE_NAME`_CTRL_PAR_SER;
#endif
	
	hCtrl->hooks.SetRotation	= `$INSTANCE_NAME`_LCD_SetRotation;
	hCtrl->hooks.DrawPixel		= `$INSTANCE_NAME`_LCD_DrawPixel;
	hCtrl->hooks.DrawVLine		= `$INSTANCE_NAME`_LCD_DrawVLine;
	hCtrl->hooks.DrawHLine		= `$INSTANCE_NAME`_LCD_DrawHLine;
	hCtrl->hooks.DrawFont		= `$INSTANCE_NAME`_LCD_DrawFont;
	hCtrl->hooks.FillRect		= `$INSTANCE_NAME`_LCD_FillRect;
	
	`$INSTANCE_NAME`_LCD_Init(j1GFX_Ctrl, dispType);
	`$J1GFX_LIB`_SetRotation(j1GFX_Ctrl, rotate);
	`$J1GFX_LIB`_SetRegion(NULL, j1GFX_Ctrl, 0, 0, hCtrl->currWidth, hCtrl->currHeight);
	`$INSTANCE_NAME`_LCD_FillRect(j1GFX_Ctrl, 0, 0, hCtrl->currWidth, hCtrl->currHeight, rgb);
	
	return true;
}

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_SetRotation()
//---------------------------------------------------------------------

void `$INSTANCE_NAME`_LCD_SetRotation(`$J1GFX_LIB`_CTRL *j1GFX_Ctrl, `$J1GFX_LIB`_ROTATE rotate)
{
#if `$INSTANCE_NAME`_PARAM_SENDER
	cmds.LCD_SetRotation.cmd	= CMD_LCD_SETROTATION;
	cmds.LCD_SetRotation.ctrl	= HY28B_Ctrl;
	cmds.LCD_SetRotation.rotate	= rotate;
	cmds.LCD_SetRotation.rgb	= rgb;
	`$INSTANCE_NAME`_Send(&cmds, sizeof(cmds.LCD_SetRotation));
#endif

	`$INSTANCE_NAME`_CTRL	*hCtrl;
	hCtrl = j1GFX_Ctrl->hardware;

	switch (rotate)
	{
	case `$J1GFX_LIB`_ROTATE_N:
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE || `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
		`$INSTANCE_NAME`_LCD_WriteReg(0x03, `$INSTANCE_NAME`_LCD_EM_03_BGR | `$INSTANCE_NAME`_LCD_EM_03_ID0 | `$INSTANCE_NAME`_LCD_EM_03_AM);
#endif
		hCtrl->currWidth	= `$INSTANCE_NAME`_LCD_TFTHEIGHT;
		hCtrl->currHeight	= `$INSTANCE_NAME`_LCD_TFTWIDTH;
    	break;
		
#if `$J1GFX_LIB`_PARAM_ROTATES
	case `$J1GFX_LIB`_ROTATE_E:
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE || `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
		`$INSTANCE_NAME`_LCD_WriteReg(0x03, `$INSTANCE_NAME`_LCD_EM_03_BGR | `$INSTANCE_NAME`_LCD_EM_03_ID1 | `$INSTANCE_NAME`_LCD_EM_03_ID0);
#endif
		hCtrl->currWidth	= `$INSTANCE_NAME`_LCD_TFTWIDTH;
		hCtrl->currHeight	= `$INSTANCE_NAME`_LCD_TFTHEIGHT;
		break;
		
	case `$J1GFX_LIB`_ROTATE_S:
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE || `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
		`$INSTANCE_NAME`_LCD_WriteReg(0x03, `$INSTANCE_NAME`_LCD_EM_03_BGR | `$INSTANCE_NAME`_LCD_EM_03_ID1 | `$INSTANCE_NAME`_LCD_EM_03_AM);
#endif
		hCtrl->currWidth	= `$INSTANCE_NAME`_LCD_TFTHEIGHT;
		hCtrl->currHeight	= `$INSTANCE_NAME`_LCD_TFTWIDTH;
		break;
		
	case `$J1GFX_LIB`_ROTATE_W:
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE || `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
		`$INSTANCE_NAME`_LCD_WriteReg(0x03, `$INSTANCE_NAME`_LCD_EM_03_BGR);
#endif
		hCtrl->currWidth	= `$INSTANCE_NAME`_LCD_TFTWIDTH;
		hCtrl->currHeight	= `$INSTANCE_NAME`_LCD_TFTHEIGHT;
		break;
#endif
		
	default:
		return;
	}
	
	hCtrl->currRotation	= rotate;
	
	j1GFX_Ctrl->displayWidth	= hCtrl->currWidth;
	j1GFX_Ctrl->displayHeight	= hCtrl->currHeight;
}

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_SetAddrWindow()
//---------------------------------------------------------------------

void `$INSTANCE_NAME`_LCD_SetAddrWindow(`$J1GFX_LIB`_CTRL *j1GFX_Ctrl, uint16 x0, uint16 y0, uint16 x1, uint16 y1)
{
	`$INSTANCE_NAME`_CTRL	*hCtrl;
	uint16	_x0, _y0, _x1, _y1, x, y;
	
	hCtrl	= j1GFX_Ctrl->hardware;
	
	switch (hCtrl->currRotation)
	{
	case `$J1GFX_LIB`_ROTATE_N:
		_x0 = y0;
		_y0 = `$INSTANCE_NAME`_LCD_TFTHEIGHT - x1 - 1;
		_x1 = y1;
		_y1 = `$INSTANCE_NAME`_LCD_TFTHEIGHT - x0 - 1;
		x   = _x0;
		y   = _y1;
		break;
		
#if `$J1GFX_LIB`_PARAM_ROTATES
	case `$J1GFX_LIB`_ROTATE_E:
		_x0 = x0;
		_y0 = y0;
		_x1 = x1;
		_y1 = y1;
		x   = x0;
		y   = y0;
		break;
		
	case `$J1GFX_LIB`_ROTATE_S:
		_x0 = `$INSTANCE_NAME`_LCD_TFTWIDTH  - y1 - 1;
		_y0 = `$INSTANCE_NAME`_LCD_TFTHEIGHT - x0 - 1;
		_x1 = `$INSTANCE_NAME`_LCD_TFTWIDTH  - y0 - 1;
		_y1 = `$INSTANCE_NAME`_LCD_TFTHEIGHT - x1 - 1;
		x   = _x1;
		y   = _y0;
		break;
		
	case `$J1GFX_LIB`_ROTATE_W:
		_x0 = x1;
		_y0 = y1;
		_x1 = x0;
		_y1 = y0;
		x   = x1;
		y   = y1;
		break;
#endif
		
	default:
		return;
	}
	
	`$INSTANCE_NAME`_LCD_WriteReg(0x50, _x0);
	`$INSTANCE_NAME`_LCD_WriteReg(0x51, _x1);
	`$INSTANCE_NAME`_LCD_WriteReg(0x52, _y0);
	`$INSTANCE_NAME`_LCD_WriteReg(0x53, _y1);
	
	`$INSTANCE_NAME`_LCD_WriteReg(0x20, x);
	`$INSTANCE_NAME`_LCD_WriteReg(0x21, y);
}

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_DrawPixel()
//---------------------------------------------------------------------

void `$INSTANCE_NAME`_LCD_DrawPixel(`$J1GFX_LIB`_CTRL *j1GFX_Ctrl, int16 x, int16 y, uint32 rgb)
{
#if `$INSTANCE_NAME`_PARAM_SENDER
	cmds.LCD_DrawPixel.cmd		= CMD_LCD_DRAWPIXEL;
	cmds.LCD_DrawPixel.x		= x;
	cmds.LCD_DrawPixel.y		= y;
	cmds.LCD_DrawPixel.rgb		= rgb;
	`$INSTANCE_NAME`_Send(&cmds, sizeof(cmds.LCD_DrawPixel));
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE || `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
	`$INSTANCE_NAME`_CTRL	*hCtrl;
	uint16					color;
	
	hCtrl	= j1GFX_Ctrl->hardware;
	color	= `$INSTANCE_NAME`_LCD_Color565(rgb);

	if ((x < 0) || (x >= hCtrl->currWidth) || (y < 0) || (y >= hCtrl->currHeight)) return;
	
	`$INSTANCE_NAME`_LCD_SetAddrWindow(j1GFX_Ctrl, x, y, x+1, y+1);
	`$INSTANCE_NAME`_LCD_WriteReg(0x22, color);
#endif
}

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_DrawVLine()
//---------------------------------------------------------------------

void `$INSTANCE_NAME`_LCD_DrawVLine(`$J1GFX_LIB`_CTRL *j1GFX_Ctrl, int16 x, int16 y, int16 h, uint32 rgb)
{
#if `$INSTANCE_NAME`_PARAM_SENDER
	cmds.LCD_DrawVLine.cmd		= CMD_LCD_DRAWVLINE;
	cmds.LCD_DrawVLine.x		= x;
	cmds.LCD_DrawVLine.y		= y;
	cmds.LCD_DrawVLine.h		= h;
	cmds.LCD_DrawVLine.rgb		= rgb;
	`$INSTANCE_NAME`_Send(&cmds, sizeof(cmds.LCD_DrawVLine));
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE || `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
//	`$INSTANCE_NAME`_CTRL	*hCtrl;
	uint16		color;
	uint8		hi, lo;
	
//	hCtrl	= j1GFX_Ctrl->hardware;
	color	= `$INSTANCE_NAME`_LCD_Color565(rgb);
	hi		= color >> 8;
	lo		= color & 0x00ff;

	`$INSTANCE_NAME`_LCD_SetAddrWindow(j1GFX_Ctrl, x, y, x, y+h-1);
	`$INSTANCE_NAME`_LCD_WriteIndex(0x22);
	
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
	`$INSTANCE_NAME`_LCD_SelectLo();
	`$INSTANCE_NAME`_LCD_SpiWrite(`$INSTANCE_NAME`_LCD_START | `$INSTANCE_NAME`_LCD_WR | `$INSTANCE_NAME`_LCD_DATA);
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
	`$INSTANCE_NAME`_LCD_SelectLo();
#endif

	while (h--)
	{
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
		`$INSTANCE_NAME`_LCD_SpiWrite(hi);
		`$INSTANCE_NAME`_LCD_SpiWrite(lo);
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
		`$INSTANCE_NAME`_iLBus_Write(hi);
		`$INSTANCE_NAME`_LCD_WR_Lo();
		`$INSTANCE_NAME`_LCD_WR_Hi();
		`$INSTANCE_NAME`_iLBus_Write(lo);
		`$INSTANCE_NAME`_LCD_WR_Lo();
		`$INSTANCE_NAME`_LCD_WR_Hi();
#endif
	}

#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
	`$INSTANCE_NAME`_LCD_SpiWait();
	`$INSTANCE_NAME`_LCD_SelectHi();
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
	`$INSTANCE_NAME`_LCD_SelectHi();
#endif

#endif
}

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_DrawHLine()
//---------------------------------------------------------------------

void `$INSTANCE_NAME`_LCD_DrawHLine(`$J1GFX_LIB`_CTRL *j1GFX_Ctrl, int16 x, int16 y, int16 w, uint32 rgb)
{
#if `$INSTANCE_NAME`_PARAM_SENDER
	cmds.LCD_DrawHLine.cmd		= CMD_LCD_DRAWHLINE;
	cmds.LCD_DrawHLine.x		= x;
	cmds.LCD_DrawHLine.y		= y;
	cmds.LCD_DrawHLine.w		= w;
	cmds.LCD_DrawHLine.rgb		= rgb;
	`$INSTANCE_NAME`_Send(&cmds, sizeof(cmds.LCD_DrawHLine));
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE || `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
//	`$INSTANCE_NAME`_CTRL	*hCtrl;
	uint16					color;
	uint8					hi, lo;
	
//	hCtrl	= j1GFX_Ctrl->hardware;
	color	= `$INSTANCE_NAME`_LCD_Color565(rgb);
	hi		= color >> 8;
	lo		= color & 0x00ff;

	`$INSTANCE_NAME`_LCD_SetAddrWindow(j1GFX_Ctrl, x, y, x+w-1, y);
	`$INSTANCE_NAME`_LCD_WriteIndex(0x22);

#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
	`$INSTANCE_NAME`_LCD_SelectLo();
	`$INSTANCE_NAME`_LCD_SpiWrite(`$INSTANCE_NAME`_LCD_START | `$INSTANCE_NAME`_LCD_WR | `$INSTANCE_NAME`_LCD_DATA);
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
	`$INSTANCE_NAME`_LCD_SelectLo();
#endif

	while (w--)
	{
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
		`$INSTANCE_NAME`_LCD_SpiWrite(hi);
		`$INSTANCE_NAME`_LCD_SpiWrite(lo);
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
		`$INSTANCE_NAME`_iLBus_Write(hi);
		`$INSTANCE_NAME`_LCD_WR_Lo();
		`$INSTANCE_NAME`_LCD_WR_Hi();
		`$INSTANCE_NAME`_iLBus_Write(lo);
		`$INSTANCE_NAME`_LCD_WR_Lo();
		`$INSTANCE_NAME`_LCD_WR_Hi();
#endif
	}

#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
	`$INSTANCE_NAME`_LCD_SpiWait();
	`$INSTANCE_NAME`_LCD_SelectHi();
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
	`$INSTANCE_NAME`_LCD_SelectHi();
#endif

#endif
}

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_FillRect()
//---------------------------------------------------------------------

void `$INSTANCE_NAME`_LCD_FillRect(`$J1GFX_LIB`_CTRL *j1GFX_Ctrl, int16 x, int16 y, int16 w, int16 h, uint32 rgb)
{
#if `$INSTANCE_NAME`_PARAM_SENDER
	cmds.LCD_FillRect.cmd		= CMD_LCD_FILLRECT;
	cmds.LCD_FillRect.x			= x;
	cmds.LCD_FillRect.y			= y;
	cmds.LCD_FillRect.w			= w;
	cmds.LCD_FillRect.h			= h;
	cmds.LCD_FillRect.rgb		= rgb;
	`$INSTANCE_NAME`_Send(&cmds, sizeof(cmds.LCD_FillRect));
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE || `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
//	`$INSTANCE_NAME`_CTRL	*hCtrl;
	uint16					color;
	uint8					hi, lo;
	uint32					pixels;
#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
	register	reg8		*dPtr;
	register	reg8		*cPtr;
#endif
	
//	hCtrl	= j1GFX_Ctrl->hardware;
	color	= `$INSTANCE_NAME`_LCD_Color565(rgb);
	hi		= color >> 8;
	lo		= color & 0x00ff;
	pixels	= w * h;
#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
	dPtr	= &`$INSTANCE_NAME`_iLBus_DR;
	cPtr	= `$INSTANCE_NAME`_iCtrl_Control_PTR;
#endif

	`$INSTANCE_NAME`_LCD_SetAddrWindow(j1GFX_Ctrl, x, y, x+w-1, y+h-1);
	`$INSTANCE_NAME`_LCD_WriteIndex(0x22);
	
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
	`$INSTANCE_NAME`_LCD_SelectLo();
	`$INSTANCE_NAME`_LCD_SpiWrite(`$INSTANCE_NAME`_LCD_START | `$INSTANCE_NAME`_LCD_WR | `$INSTANCE_NAME`_LCD_DATA);
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
	`$INSTANCE_NAME`_LCD_SelectLo();
#endif

	while (pixels--)
	{
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
		`$INSTANCE_NAME`_LCD_SpiWrite(hi);
		`$INSTANCE_NAME`_LCD_SpiWrite(lo);
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
		*dPtr = hi;
//		HY28B_CTRL_WR_BB = 0;
//		HY28B_CTRL_WR_BB = 1;
		*cPtr &= ~`$INSTANCE_NAME`_CTRL_WR;
		*cPtr |=  `$INSTANCE_NAME`_CTRL_WR;
//		HY28B_Bus_Write(hi);
//		HY28B_WR_Lo();
//		HY28B_WR_Hi();
		*dPtr = lo;
		*cPtr &= ~`$INSTANCE_NAME`_CTRL_WR;
		*cPtr |=  `$INSTANCE_NAME`_CTRL_WR;
//		HY28B_Bus_Write(lo);
//		HY28B_WR_Lo();
//		HY28B_WR_Hi();
#endif
	}

#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
	`$INSTANCE_NAME`_LCD_SpiWait();
	`$INSTANCE_NAME`_LCD_SelectHi();
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
	`$INSTANCE_NAME`_LCD_SelectHi();
#endif

#endif
}

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_LCD_DrawFont()
//---------------------------------------------------------------------

void `$INSTANCE_NAME`_LCD_DrawFont(`$J1GFX_LIB`_CTRL *j1GFX_Ctrl, int16_t x, int16_t y, char c, `$J1GFX_LIB`_FONT font, uint16 w, uint16 h, uint8 scale, uint32 fgRGB, uint32 bgRGB)
{
#if `$J1GFX_LIB`_PARAM_FONT_5X7 || `$J1GFX_LIB`_PARAM_NUM_5X7 || `$J1GFX_LIB`_PARAM_FONT_8X12 || `$J1GFX_LIB`_PARAM_NUM_8X12
	
#if `$INSTANCE_NAME`_PARAM_SENDER
	cmds.LCD_DrawFont.cmd		= CMD_LCD_DRAWFONT;
	cmds.LCD_DrawFont.x			= x;
	cmds.LCD_DrawFont.y			= y;
	cmds.LCD_DrawFont.c			= c;
	cmds.LCD_DrawFont.font		= font;
	cmds.LCD_DrawFont.w			= w;
	cmds.LCD_DrawFont.h			= h;
	cmds.LCD_DrawFont.fgRGB565	= fgRGB;
	cmds.LCD_DrawFont.bgRGB565	= bgRGB;
	`$INSTANCE_NAME`_Send(&cmds, sizeof(cmds.LCD_DrawFont));
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE || `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
//	`$INSTANCE_NAME`_CTRL	*hCtrl;
	uint8					uc;
	uint8					i,j,line;
	uint16					fgColor, bgColor;
	uint8					fgHi, fgLo, bgHi, bgLo;
//	register reg8			*dPtr;
//	register reg8			*cPtr;
	uint8					repX, repY;
#if `$J1GFX_LIB`_PARAM_FONT_5X7 || `$J1GFX_LIB`_PARAM_NUM_5X7
	uint8					lines[6];
#endif
	
//	hCtrl	= j1GFX_Ctrl->hardware;
	
	uc = (uint8) c;
	
	fgColor	= `$INSTANCE_NAME`_LCD_Color565(fgRGB);
	fgHi	= fgColor >> 8;
	fgLo	= fgColor & 0xff;

	bgColor	= `$INSTANCE_NAME`_LCD_Color565(bgRGB);
	bgHi	= bgColor >> 8;
	bgLo	= bgColor & 0xff;
	
//	dPtr		= &HY28B_Bus_DR;
//	cPtr		= HY28B_Ctrl_Control_PTR;
	
	switch (font)
	{
#if `$J1GFX_LIB`_PARAM_FONT_5X7 || `$J1GFX_LIB`_PARAM_NUM_5X7
	case `$J1GFX_LIB`_FONT_5X7:
#if `$J1GFX_LIB`_PARAM_FONT_5X7
		if (uc < 0x20 || 0x7f < uc) return;
		uc -= 0x20;
#else
		if (uc < 0x30 || 0x3a < uc) return;
		uc -= 0x30;
#endif
		
//		taskENTER_CRITICAL();
		
		for (i = 0; i < 5; i++)
		{
			lines[i] = `$J1GFX_LIB`_Font5x7[5*uc + i];
		}
		
		lines[5] = 0;
	
		`$INSTANCE_NAME`_LCD_SetAddrWindow(j1GFX_Ctrl, x, y, x+w-1, y+h-1);
		`$INSTANCE_NAME`_LCD_WriteIndex(0x22);

#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
		`$INSTANCE_NAME`_LCD_SelectLo();
		`$INSTANCE_NAME`_LCD_SpiWrite(`$INSTANCE_NAME`_LCD_START | `$INSTANCE_NAME`_LCD_WR | `$INSTANCE_NAME`_LCD_DATA);
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
		`$INSTANCE_NAME`_LCD_SelectLo();
#endif

		j = 8;

		while (j--) for (repX = 0; repX < scale; repX++)
		{
			for (i = 0; i < 6; i++)
			{
				for (repY = 0; repY < scale; repY++)
				{
					if (lines[i] & 0x1)
					{
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
						`$INSTANCE_NAME`_LCD_SpiWrite(fgHi);
						`$INSTANCE_NAME`_LCD_SpiWrite(fgLo);
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
//						*dPtr  = fgHi;
//						*cPtr &= ~HY28B_CTRL_WR;
//						*cPtr |=  HY28B_CTRL_WR;
//						*dPtr  = fgLo;
//						*cPtr &= ~HY28B_CTRL_WR;
//						*cPtr |=  HY28B_CTRL_WR;
						`$INSTANCE_NAME`_iLBus_Write(fgHi);
						`$INSTANCE_NAME`_LCD_WR_Lo();
						`$INSTANCE_NAME`_LCD_WR_Hi();
						`$INSTANCE_NAME`_iLBus_Write(fgLo);
						`$INSTANCE_NAME`_LCD_WR_Lo();
						`$INSTANCE_NAME`_LCD_WR_Hi();
#endif
					}
			
					else
					{
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
						`$INSTANCE_NAME`_LCD_SpiWrite(bgHi);
						`$INSTANCE_NAME`_LCD_SpiWrite(bgLo);
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
//						*dPtr  = bgHi;
//						*cPtr &= ~HY28B_CTRL_WR;
//						*cPtr |=  HY28B_CTRL_WR;
//						*dPtr  = bgLo;
//						*cPtr &= ~HY28B_CTRL_WR;
//						*cPtr |=  HY28B_CTRL_WR;
						`$INSTANCE_NAME`_iLBus_Write(bgHi);
						`$INSTANCE_NAME`_LCD_WR_Lo();
						`$INSTANCE_NAME`_LCD_WR_Hi();
						`$INSTANCE_NAME`_iLBus_Write(bgLo);
						`$INSTANCE_NAME`_LCD_WR_Lo();
						`$INSTANCE_NAME`_LCD_WR_Hi();
#endif
					}
				}

				lines[i] >>= 1;
			}
		}

#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
		`$INSTANCE_NAME`_LCD_SpiWait();
		`$INSTANCE_NAME`_LCD_SelectHi();
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
		`$INSTANCE_NAME`_LCD_SelectHi();
#endif
		break;
#endif

#if `$J1GFX_LIB`_PARAM_FONT_8X12 || `$J1GFX_LIB`_PARAM_NUM_8X12
	case `$J1GFX_LIB`_FONT_8X12:
#if `$J1GFX_LIB`_PARAM_FONT_8X12
		if (uc < 0x20 || 0x7f < uc) return;
		uc -= 0x20;
#else
		if (uc < 0x30 || 0x3a < uc) return;
		uc -= 0x30;
#endif
	
//		taskENTER_CRITICAL();

		`$INSTANCE_NAME`_LCD_SetAddrWindow(j1GFX_Ctrl, x, y, x+w-1, y+h-1);
		`$INSTANCE_NAME`_LCD_WriteIndex(0x22);
		
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
		`$INSTANCE_NAME`_LCD_SelectLo();
		`$INSTANCE_NAME`_LCD_SpiWrite(`$INSTANCE_NAME`_LCD_START | `$INSTANCE_NAME`_LCD_WR | `$INSTANCE_NAME`_LCD_DATA);
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
		`$INSTANCE_NAME`_LCD_SelectLo();
#endif

		for (i = 0; i < 12; i++) for (repX = 0; repX < scale; repX++)
		{
			line = `$J1GFX_LIB`_Font8x12[12*uc + i];
		
			j = 8;
	
			while (j--)
			{
				for (repY = 0; repY < scale; repY++)
				{
					if (line & 0x80)
					{
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
						`$INSTANCE_NAME`_LCD_SpiWrite(fgHi);
						`$INSTANCE_NAME`_LCD_SpiWrite(fgLo);
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
						`$INSTANCE_NAME`_iLBus_Write(fgHi);
						`$INSTANCE_NAME`_LCD_WR_Lo();
						`$INSTANCE_NAME`_LCD_WR_Hi();
						`$INSTANCE_NAME`_iLBus_Write(fgLo);
						`$INSTANCE_NAME`_LCD_WR_Lo();
						`$INSTANCE_NAME`_LCD_WR_Hi();
#endif
}
			
					else
					{
#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
						`$INSTANCE_NAME`_LCD_SpiWrite(bgHi);
						`$INSTANCE_NAME`_LCD_SpiWrite(bgLo);
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
						`$INSTANCE_NAME`_iLBus_Write(bgHi);
						`$INSTANCE_NAME`_LCD_WR_Lo();
						`$INSTANCE_NAME`_LCD_WR_Hi();
						`$INSTANCE_NAME`_iLBus_Write(bgLo);
						`$INSTANCE_NAME`_LCD_WR_Lo();
						`$INSTANCE_NAME`_LCD_WR_Hi();
#endif

					}
				}

				line <<= 1;
			}
		}

#if `$INSTANCE_NAME`_PARAM_LCD_SPI_MODE
		`$INSTANCE_NAME`_LCD_SpiWait();
		`$INSTANCE_NAME`_LCD_SelectHi();
#endif

#if `$INSTANCE_NAME`_PARAM_LCD_PAR_MODE
		`$INSTANCE_NAME`_LCD_SelectHi();
#endif
		break;
#endif

	default:
		break;
	}
	
//	taskEXIT_CRITICAL();
#endif

#endif
}
