//=====================================================================
//
//	`$INSTANCE_NAME`_Touch.hh - HAOYU 2.8" GFX Driver
//
//	version 1.1 - 15 feb 2014
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#if !defined(`$INSTANCE_NAME`_TOUCH_HH)
#define `$INSTANCE_NAME`_TOUCH_HH

//#include "`$J1GFX_INSTANCE`.h"
	
typedef	struct	_`$INSTANCE_NAME`_Touch_Point
{
	uint16	x;
	uint16	y;
} `$INSTANCE_NAME`_Touch_Point;

typedef	struct	_`$INSTANCE_NAME`_Touch_Matrix
{
	long double	An, Bn, Cn, Dn, En, Fn, Divider;
} `$INSTANCE_NAME`_Touch_Matrix;

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_Touch hardware ctrl
//---------------------------------------------------------------------

typedef struct _`$INSTANCE_NAME`_Touch_CTRL
{
	`$INSTANCE_NAME`_Touch_Matrix	matrix;
	
	`$INSTANCE_NAME`_Touch_Point	ADC_Points[3];
	`$INSTANCE_NAME`_Touch_Point	*XY_Points;

} `$INSTANCE_NAME`_Touch_CTRL;

bool	`$INSTANCE_NAME`_Touch_Touched(void);

#if `$INSTANCE_NAME`_PARAM_TOUCH_SPI_ENABLE
bool	`$INSTANCE_NAME`_Touch_ReadADC(`$INSTANCE_NAME`_Touch_Point *point);
void	`$INSTANCE_NAME`_Touch_Calibrate(`$J1GFX_LIB`_CTRL *j1GFX_Ctrl, `$INSTANCE_NAME`_Touch_CTRL *preload);
bool	`$INSTANCE_NAME`_Touch_CalcCalibrationMatrix(`$INSTANCE_NAME`_Touch_CTRL *touch_Ctrl);
bool	`$INSTANCE_NAME`_Touch_GetTouchXY(`$INSTANCE_NAME`_Touch_CTRL *touch_Ctrl, bool waitUp, `$INSTANCE_NAME`_Touch_Point *touchXY);
bool	`$INSTANCE_NAME`_Touch_CtrlToString(`$INSTANCE_NAME`_Touch_CTRL *touch_Ctrl, char *bfr, uint8 bfrSize);
bool	`$INSTANCE_NAME`_Touch_StringToCtrl(char *bfr, `$INSTANCE_NAME`_Touch_CTRL *touch_Ctrl);
#endif

#endif
