//=====================================================================
//
//	`$INSTANCE_NAME`.h - j1sys device independent put lib
//
//	version 1.2 - 15 jan 2015
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JOSHUA 1 SYSTEMS INC. OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#if !defined(`$INSTANCE_NAME`_H)
#define `$INSTANCE_NAME`_H
	
#define	`$j1LIB_NAME`_LIB		1
	
//---------------------------------------------------------------------
//	processor dependent includes
//---------------------------------------------------------------------
	
#include <cytypes.h>

//---------------------------------------------------------------------
//	stdlib includes
//---------------------------------------------------------------------

#include <stdbool.h>
#include <string.h>
	
//---------------------------------------------------------------------
//	optional j1GFX include
//---------------------------------------------------------------------
	
#if `$j1GFX_ENABLED`
#include "`$j1GFX_INSTANCE`.h"
#endif
	
//---------------------------------------------------------------------
//	`$j1LIB_NAME`_CTRL
//---------------------------------------------------------------------
	
typedef struct _`$j1LIB_NAME`_CTRL
{
	void	(*Put_Char)		(void *deviceCtrl, char c);
	void	*deviceCtrl;	// device control struct pointer
	
} `$j1LIB_NAME`_CTRL;

//---------------------------------------------------------------------
//	formatting options
//---------------------------------------------------------------------

#define	`$j1LIB_NAME`_HEX_PREFIX	(0x0001)
#define	`$j1LIB_NAME`_HEX_LOWER		(0x0002)

#define	`$j1LIB_NAME`_HEXDUMPA32	(0x0010)
#define	`$j1LIB_NAME`_HEXDUMP16		(0x0020)
#define	`$j1LIB_NAME`_HEXDUMPASC	(0x0040)

#define	`$j1LIB_NAME`_PRESPC		(0x1000)
#define	`$j1LIB_NAME`_PSTSPC		(0x2000)

//---------------------------------------------------------------------
//	function prototypes
//---------------------------------------------------------------------

void	`$j1LIB_NAME`_Start			(`$j1LIB_NAME`_CTRL *pC, void *Put_Char, void *deviceCtrl);
void	`$j1LIB_NAME`_Char			(`$j1LIB_NAME`_CTRL *pC, char c);
void	`$j1LIB_NAME`_String		(`$j1LIB_NAME`_CTRL *pC, char *string);
void	`$j1LIB_NAME`_StringOpt		(`$j1LIB_NAME`_CTRL *pC, char *string, uint16 options);
void	`$j1LIB_NAME`_StringField	(`$j1LIB_NAME`_CTRL *pC, char *string, uint16 length, uint16 options);
void	`$j1LIB_NAME`_Field			(`$j1LIB_NAME`_CTRL *pC, char *field, uint16 length, uint16 options);
void	`$j1LIB_NAME`_Hex8			(`$j1LIB_NAME`_CTRL *pC, uint8 hex, uint16 options);
void	`$j1LIB_NAME`_Hex16			(`$j1LIB_NAME`_CTRL *pC, uint16 hex, uint16 options);
void	`$j1LIB_NAME`_Hex32			(`$j1LIB_NAME`_CTRL *pC, uint32 hex, uint16 options);
void	`$j1LIB_NAME`_HexDump		(`$j1LIB_NAME`_CTRL *pC, uint32 addrHex, uint8 *bfr, uint8 lo, uint8 hi, uint16 options);

#if `$j1GFX_ENABLED`
void	`$j1LIB_NAME`_FillRegion	(`$j1LIB_NAME`_CTRL *pC, uint32 rgb);
void	`$j1LIB_NAME`_SetFontFgBg	(`$j1LIB_NAME`_CTRL *pC, `$j1GFX_LIB`_FONT font, uint8 scale, uint32 fg, uint32 bg);
void	`$j1LIB_NAME`_SetTextRowCol	(`$j1LIB_NAME`_CTRL *pC, uint8 row, uint8 col);
void	`$j1LIB_NAME`_SetTextXY		(`$j1LIB_NAME`_CTRL *pC, uint16 x, uint16 y);
#endif

#endif	// `$j1LIB_NAME`_H
