//=====================================================================
//
//	`$INSTANCE_NAME`.h - j1sys spi flash for sst25 series
//
//	version 1.0 - 16 dec 2013
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#if !defined(`$INSTANCE_NAME`_H)
#define `$INSTANCE_NAME`_H

//#include <project.h>
//#include <stdbool.h>

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_CTRL
//---------------------------------------------------------------------
	
typedef struct _`$INSTANCE_NAME`_CTRL
{
	uint8	mfgID;
	uint8	devID;
	
	union
	{
		unsigned char v;
		
		struct
		{
			unsigned char bWriteWordStream : 1;	// Supports AAI Word opcode (0xAD)
			unsigned char bWriteByteStream : 1;	// Supports AAI Byte opcode (0xAF)
			unsigned char bPageProgram : 1;		// Supports Byte program opcode with up to 256 bytes/page (0x02)
			unsigned char filler : 5;
		} bits;
	} deviceCaps;
	
	uint32	writeAddr;
	
} `$INSTANCE_NAME`_CTRL;

//---------------------------------------------------------------------
//	`$INSTANCE_NAME` Constants
//---------------------------------------------------------------------

#define `$INSTANCE_NAME`_SECTOR_SIZE		(4096ul)
#define `$INSTANCE_NAME`_PAGE_SIZE			(0ul)
#define `$INSTANCE_NAME`_SECTOR_MASK		(`$INSTANCE_NAME`_SECTOR_SIZE - 1)


//---------------------------------------------------------------------
//	`$INSTANCE_NAME` Function Prototypes
//---------------------------------------------------------------------

bool `$INSTANCE_NAME`_Start(`$INSTANCE_NAME`_CTRL *j1SpiFlash_Ctrl);		
bool `$INSTANCE_NAME`_ReadArray(`$INSTANCE_NAME`_CTRL *j1SpiFlash_Ctrl, DWORD dwAddress, BYTE *vData, WORD wLen);
bool `$INSTANCE_NAME`_BeginWrite(`$INSTANCE_NAME`_CTRL *j1SpiFlash_Ctrl, DWORD dwAddr);
bool `$INSTANCE_NAME`_Write(`$INSTANCE_NAME`_CTRL *j1SpiFlash_Ctrl, BYTE vData);
bool `$INSTANCE_NAME`_WriteArray(`$INSTANCE_NAME`_CTRL *j1SpiFlash_Ctrl, BYTE *vData, WORD wLen);
bool `$INSTANCE_NAME`_EraseSector(`$INSTANCE_NAME`_CTRL *j1SpiFlash_Ctrl, DWORD dwAddr);
	
#endif
