//=====================================================================
//
//	`$INSTANCE_NAME`_ConsoleCmd.c - j1UBL project design command code
//
//	version 1.2 - 16 apr 2015
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#include "`$INSTANCE_NAME`_ConsoleCmd.h"

//---------------------------------------------------------------------
//
//	ConsoleCmd_Start() - initialize console command
//
//---------------------------------------------------------------------

void `$INSTANCE_NAME`_ConsoleCmd_Start(void)
{
}

//---------------------------------------------------------------------
//
//	ConsoleCmd_Tasks() - execute terminal command entry
//
//---------------------------------------------------------------------


bool `$INSTANCE_NAME`_ConsoleCmd_Tasks(void)
{
	j1XML_ELEMENT_GEN(cmd, 8, 8, 16, 32);
	j1XML_RESULT	j1XML_Result;
	bool	cmdError = false;
//	char	*errorMsg;

	int		i, j;
	bool	helpFlag;
	j1XML_DICT_ELEM	const *eDict;
			
	if (!j1ConsoleCmd.bfrRdy) return false;

	if (j1ConsoleCmd.bfrCnt)
	{
		if (!cmdError) if ((j1XML_Result = j1XML_Open(j1XML_IOMODE_READ_MEM, (uint32) j1ConsoleCmd.bfr, j1ConsoleCmd.bfrCnt)) != j1XML_RESULT_OK) cmdError = true;
		if (!cmdError) if ((j1XML_Result = j1XML_ReadElement(0, &cmd, true)) != j1XML_RESULT_OK) cmdError = true;
		if (!cmdError) if ((j1XML_Result = j1XML_ParseElement(&cmd, CmdXML_eTbl_size, CmdXML_eTbl, NULL, 0, NULL, true)) != j1XML_RESULT_OK) cmdError = true;

		if (!cmdError)
		{
			switch(cmd.eID)
			{
			case CMDXML_DEBUG:
				j1ConsoleCmd.first = true;
				j1ConsoleCmd.debug = true;
				break;
				
			case CMDXML_D:
				if (j1ConsoleCmd.debug)
				{
					j1Console_DumpCmd(&cmd);
				}
				break;

			case CMDXML_HELP:
				helpFlag = false;
				for (i = 0; i < cmd.aCount; i++)
				{
					if (cmd.aIDTbl[i])
					{
						j1Console_PutCRLF();
						j1Console_PutString("command: ");
						j1Console_PutString(cmd.aBfr + i * (cmd.aNameSize + cmd.aValueSize));

						eDict = NULL;

//						switch (cmd.aIDTbl[i])
//						{
//						case CMDXML_HELP_CONFIG:
//							break;
//
//						case CMDXML_HELP_STATS:
//							break;
//
//						case CMDXML_HELP_NETWORK:
//							eDict = &CmdXML_network;
//							break;
//
//						case CMDXML_HELP_STRING:
//							eDict = &CmdXML_string;
//							break;
//						}

						if (eDict != NULL)
						{
							for (j = 0; j < eDict->aCnt; j++)
							{
								j1Console_Put(' ');
								j1Console_PutString(eDict->aTbl[j]->name);
								j1Console_Put('=');
							}
							j1Console_PutCRLF();
							j1Console_PutString("Values containing spaces must be contained inside of quotes. i.e.: set host='Test 1'");
						}

						j1Console_PutCRLF();
						helpFlag = true;
					}
				}

				if (!helpFlag)
				{
					j1Console_PutCRLF();
					j1Console_PutString("commands:");
					for (i = CMDXML_HELP - 1; i < CmdXML_eTbl_size; i++)
					{
						if (i >= CMDXML_HELP) j1Console_Put(',');
						j1Console_Put(' ');
						j1Console_PutString(CmdXML_eTbl[i]->name);
					}
					j1Console_PutCRLF();
					j1Console_PutString("Type 'help' followed by the command name for more details");
					j1Console_PutCRLF();
				}

				j1Console_PutCRLF();
				break;

			case CMDXML_STATUS:
				j1Console_PutCRLF();
				j1Console_PutString("SAK_PROTO (UBL) Status");
				j1Console_PutCRLF();
				break;
				
			case CMDXML_CONFIG:
				j1Console_PutCRLF();
				j1Console_PutString("SAK-PROTO (UBL) Configuration");
				j1Console_PutCRLF();
				j1Console_PutCRLF();
				break;

			case CMDXML_STATS:
				j1Console_PutCRLF();
				j1Console_PutString("SAK-PROTO (UBL) Statistics");
				j1Console_PutCRLF();
				break;

//			case CMDXML_DUMP:
//				ExtFlashReadArray(__XML_CONFIG_ADDR, dumpBfr, sizeof(dumpBfr));
//				for (i = 0; i < sizeof(dumpBfr); i++)
//				{
//					if (i % 16 == 0) j1Console_PutCRLF();
//					else j1Console_Put(' ');
//					j1Console_PutHEXBYTE(dumpBfr[i]);
//				}
				
#if defined(DMX_DUMP_SIZE)
//				ConsolePutDWORD(DMXControl.dumpCnt);
//				for (i = 0; i < DMXControl.dumpCnt; i++)
//				{
//					if (i % 8 == 0) ConsolePutCRLF();
//					else ConsolePut(' ');
//					ConsolePutHEXBYTE(DMXControl.staBfr[i]);
//					ConsolePut(':');
//					ConsolePutHEXBYTE(DMXControl.rxBfr[i]);
//					ConsolePut(':');
//					ConsolePutHEXBYTE(DMXControl.cntBfr[i]);
//				}
#endif
//				j1Console_PutCRLF();
//				break;

//			case CMDXML_XML:
//				ExtFlashReadArray(__XML_CONFIG_ADDR, dumpBfr, sizeof(dumpBfr));
//				for (i = 0; i < sizeof(dumpBfr); i++)
//				{
//					if (dumpBfr[i] == 0xff) break;
//					j1Console_Put(dumpBfr[i]);
//				}
//				j1Console_PutCRLF();
//				break;

			case CMDXML_REBOOT:
				j1Console_PutString("Rebooting ...\r\n");
//				upTimeRebootTick = TickGet();
				break;

			case CMDXML_EXIT:
				j1Console_Put(0x7f);
				break;
			}
		}

		else
		{
//			errorMsg = j1XML_ErrorDecode(j1XML_Result);
//			j1Console_PutString(errorMsg);
			j1Console_PutString("???");
			j1Console_PutCRLF();
		}
	}

	if (j1ConsoleCmd.first)
	{ 
		j1Console_PutString("\r\nSAK-PROTO (UBL) ");
		if (j1ConsoleCmd.debug) { j1Console_PutString("Debug "); }
		j1Console_PutString("Console v1.0\r\n\r\n");
	}
	
	if (j1ConsoleCmd.debug) { j1Console_PutString("debug> "); }
			  else { j1Console_PutString("cmd> "); }

	j1ConsoleCmd.bfrPtr = j1ConsoleCmd.bfr;
	j1ConsoleCmd.bfrCnt = 0;
	j1ConsoleCmd.bfrRdy = false;
	j1ConsoleCmd.first  = false;

	return true;
}
