//=====================================================================
//
//	`$INSTANCE_NAME`.c - j1UBL project design code
//
//	version 1.2 - 16 apr 2015
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#include <project.h>
//#include "`$INSTANCE_NAME`.h"
//#include "`$INSTANCE_NAME`_main.h"

j1Put_CTRL	*__pC;
uint32	wanker;

#if defined(`$INSTANCE_NAME`_COMM_XXX)
void `$INSTANCE_NAME`_Service_ETH0_Rx();
#endif

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_CommStart()
//---------------------------------------------------------------------

#if defined(`$INSTANCE_NAME`_COMM_XXX)
void `$INSTANCE_NAME`_CommStart(void)
{
#if `$INSTANCE_NAME`_PARAM_J1CONSOLE_ENABLED
	j1Console_Start();
#endif

#if `$INSTANCE_NAME`_PARAM_ETH_ENABLED
	`$INSTANCE_NAME`_ETH0_CyBtldrCommStart();
#endif

#if `$INSTANCE_NAME`_PARAM_USB_ENABLED
	`$INSTANCE_NAME`_USBFS_CyBtldrCommStart();
#endif

#if `$INSTANCE_NAME`_PARAM_UART_ENABLED
	UART_CyBtldrCommStart();
#endif

	`$INSTANCE_NAME`_comm_mode = `$INSTANCE_NAME`_COMM_MODE_UNKNOWN;
}
#endif	// defined(`$INSTANCE_NAME`_COMM_XXX)


//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_CommStop()
//---------------------------------------------------------------------

#if defined(`$INSTANCE_NAME`_COMM_XXX)
void `$INSTANCE_NAME`_CommStop(void)
{
#if `$INSTANCE_NAME`_PARAM_USB_ENABLED
	`$INSTANCE_NAME`_USBFS_CyBtldrCommStop();
#endif

#if `$INSTANCE_NAME`_PARAM_UART_ENABLED
	UART_CyBtldrCommStop();
#endif
}
#endif	// defined(`$INSTANCE_NAME`_COMM_XXX)

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_CommWrite()
//---------------------------------------------------------------------

#if defined(`$INSTANCE_NAME`_COMM_XXX)
cystatus `$INSTANCE_NAME`_CommWrite(uint8* buffer, uint16 size, uint16* count, uint8 timeOut)
{
#define	MAX_PACKET	300

	cystatus	status;
	uint16		maxPacket;
	uint16		dataOffset;
	uint8		pktBfr[MAX_PACKET];
	uint8		*bfrPtr;
	uint16		pktSize, xxxSize, dataSize, chkSum, i;
	
	
	switch (`$INSTANCE_NAME`_comm_mode)
	{
	#if `$INSTANCE_NAME`_PARAM_ETH_ENABLED
	case `$INSTANCE_NAME`_COMM_MODE_ETH:
		maxPacket = MAX_PACKET;
		break;
	#endif
	
	#if `$INSTANCE_NAME`_PARAM_USB_ENABLED
	case `$INSTANCE_NAME`_COMM_MODE_USB:
		maxPacket = 64;
//		return `$INSTANCE_NAME`_USBFS_CyBtldrCommWrite(buffer, size, count, timeOut);
		break;
	#endif
	
	#if `$INSTANCE_NAME`_PARAM_UART_ENABLED
	case `$INSTANCE_NAME`_COMM_MODE_UART:
		maxPacket = MAX_PACKET;
		break;
	#endif
	
	default:
		return CYRET_UNKNOWN;
	}
	
	dataOffset = 0;
	
	while (size)
	{
		if (dataOffset == 0 && size <= maxPacket)
		{
			bfrPtr		= buffer;
			pktSize		= size;
			xxxSize		= size;
			dataSize	= size - 7;
		}
		
		else
		{
			bfrPtr		= pktBfr;
			pktBfr[0]	= 0x01;
			
			if (size <= maxPacket)
			{
				pktSize		= size;
				xxxSize		= size;
				dataSize	= size - 7;
				pktBfr[1]	= buffer[1];
			}
			else
			{
				pktSize		= maxPacket;
				xxxSize		= maxPacket - 7;
				dataSize	= xxxSize;
				pktBfr[1]	= 0x37;
			}
			
			pktBfr[2]	= LO8(dataSize);
			pktBfr[3]	= HI8(dataSize);
			chkSum  = pktBfr[0];
			chkSum += pktBfr[1];
			chkSum += pktBfr[2];
			chkSum += pktBfr[3];
			for (i = 0; i < dataSize; i++)
			{
				pktBfr[4+i] = buffer[4+dataOffset+i];
				chkSum += pktBfr[4+i];
			}
			chkSum = (uint16) 1 + (uint16) (~chkSum);
			pktBfr[4+dataSize] = LO8(chkSum);
			pktBfr[5+dataSize] = HI8(chkSum);
			pktBfr[6+dataSize] = 0x17;
		}
	
		switch (`$INSTANCE_NAME`_comm_mode)
		{
		#if `$INSTANCE_NAME`_PARAM_ETH_ENABLED
		case `$INSTANCE_NAME`_COMM_MODE_ETH:
			status = `$INSTANCE_NAME`_ETH0_CyBtldrCommWrite(bfrPtr, pktSize, count, timeOut);
			break;
		#endif
	
		#if `$INSTANCE_NAME`_PARAM_USB_ENABLED
		case `$INSTANCE_NAME`_COMM_MODE_USB:
			status = `$INSTANCE_NAME`_USBFS_CyBtldrCommWrite(bfrPtr, pktSize, count, timeOut);
		break;
		#endif
	
		#if `$INSTANCE_NAME`_PARAM_UART_ENABLED
		case `$INSTANCE_NAME`_COMM_MODE_UART:
			status = `$INSTANCE_NAME`_UART_CyBtldrCommWrite(bfrPtr, pktSize, count, timeOut);
			break;
		#endif
	
		default:
			return CYRET_UNKNOWN;
		}
		
		if (status != CYRET_SUCCESS) return status;
		
		size		-= xxxSize;
		dataOffset	+= dataSize;
	}
	
	return CYRET_SUCCESS;
}
#endif	// defined(`$INSTANCE_NAME`_COMM_XXX)

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_CommRead()
//---------------------------------------------------------------------

#if defined(`$INSTANCE_NAME`_COMM_XXX)
cystatus `$INSTANCE_NAME`_CommRead(uint8* buffer, uint16 size, uint16* count, uint8 timeOut)
{
	cystatus	result;
	
	while (timeOut)
	{
	#if `$INSTANCE_NAME`_PARAM_J1CONSOLE_ENABLED
		j1Console_Tasks();
	#endif
	
	#if `$INSTANCE_NAME`_PARAM_ETH_ENABLED
		`$INSTANCE_NAME`_Service_ETH0_Rx();

		result = `$INSTANCE_NAME`_ETH0_CyBtldrCommRead(buffer, size, count, 1);
		if (result == CYRET_SUCCESS)
		{
			`$INSTANCE_NAME`_comm_mode = `$INSTANCE_NAME`_COMM_MODE_ETH;
			return result;
		}
	#endif
	
	#if `$INSTANCE_NAME`_PARAM_USB_ENABLED
		result = `$INSTANCE_NAME`_USBFS_CyBtldrCommRead(buffer, size, count, 1);
		if (result == CYRET_SUCCESS)
		{
			`$INSTANCE_NAME`_comm_mode = `$INSTANCE_NAME`_COMM_MODE_USB;
			return result;
		}
	#endif

	#if `$INSTANCE_NAME`_PARAM_UART_ENABLED
		result = UART_CyBtldrCommRead(buffer, size, count, 1);
		if (result == CYRET_SUCCESS)
		{
			`$INSTANCE_NAME`_comm_mode = `$INSTANCE_NAME`_COMM_MODE_UART;
			return result;
		}
	#endif
	
		timeOut--;
	}
	
	return CYRET_UNKNOWN;
}
#endif	// defined(`$INSTANCE_NAME`_COMM_XXX)

//---------------------------------------------------------------------
//	`$INSTANCE_NAME`_CommCmd()
//---------------------------------------------------------------------

#if defined(`$INSTANCE_NAME`_COMM_XXX)
	#if (`$INSTANCE_NAME`_PARAM_J1UBL_ENABLED)

uint8 `$INSTANCE_NAME`_CommCmd(uint8* pktBfr, uint16 pktDataSize, uint8* dataBfr, uint16 dataOffset, uint16 *rspDataSize)
{
#if `$INSTANCE_NAME`_PARAM_HY28B_ENABLED
//	j1GFX_CTRL	*gC = __pC->deviceCtrl;
#endif
	uint8	cmd = pktBfr[1];
	
	switch (cmd)
	{
	//--------------------------------------------------------
	// ext_getdevicename
	//--------------------------------------------------------
	case 0xe0:
#define	UBL_SFX	" (UBL)"
		if(pktDataSize == 0u)
		{
			*rspDataSize = sizeof(PD_PARAM_DEVICE_NAME) - 1;
			
			if (*rspDataSize > 0)
			{
				memcpy(&pktBfr[`$INSTANCE_NAME`_j1UBL_DATA_ADDR], `$INSTANCE_NAME`_PARAM_DEVICE_NAME, *rspDataSize);
				memcpy(&pktBfr[`$INSTANCE_NAME`_j1UBL_DATA_ADDR + *rspDataSize], UBL_SFX, sizeof(UBL_SFX) - 1);
				*rspDataSize += sizeof(UBL_SFX) - 1;
				return CYRET_SUCCESS;
            }
		}
		break;
		
	//--------------------------------------------------------
	// ext_bootXML
	//--------------------------------------------------------

#if PD_PARAM_HY28B_ENABLED
#if PD_PARAM_ETH_ENABLED
	#define	EMPTY_XML	"<ubl host='' ip='10.10.10.10' nm='255.0.0.0' pwd='' hy28b=''/>"
#else
	#define	EMPTY_XML	"<ubl host='' hy28b=''/>"
#endif

#else
#if PD_PARAM_ETH_ENABLED
	#define	EMPTY_XML	"<ubl host='' ip='10.10.10.10' nm='255.0.0.0' pwd=''/>"
#else
	#define	EMPTY_XML	"<ubl host=''/>"
#endif
#endif

	case 0xe1:
		if (dataOffset == 0 && pktDataSize == 0u)
		{
			uint8	*eeBfr;
			uint8	*rspBfr;
			
			CyEEPROM_Start();
			CyDelay(1);
			eeBfr  = (uint8 *) CY_EEPROM_BASE;
			rspBfr = &pktBfr[PD_j1UBL_DATA_ADDR];
			*rspDataSize = 0;
			
			while (*eeBfr != 0x00)
			{
				*rspBfr++ = *eeBfr++;
				(*rspDataSize)++;
			}
						
			if (*rspDataSize == 0)
			{
				*rspDataSize = sizeof(EMPTY_XML) - 1;
				memcpy(rspBfr, EMPTY_XML, *rspDataSize);
			}
			
			return CYRET_SUCCESS;
		}
		
		else
		{
			j1XML_ELEMENT_GEN(element, 8, 16, 8, 32);
			uint16			eStack[1];
			int				depth;
			j1UBL_TOKEN_XXX	tokenXXX;
			j1XML_RESULT	j1XML_Result;

			uint8		*cmdBfr;
			uint8		eeBfr[CY_EEPROM_SIZEOF_ROW];
			uint16		eeRowNum;
			uint16		rowIndex;
			cystatus	cyret;
			
            if (pktDataSize)
			{
				memcpy(&dataBfr[dataOffset], &pktBfr[PD_j1UBL_DATA_ADDR], pktDataSize);
				pktDataSize += dataOffset;
			}
			
			*rspDataSize = 0;

			depth		= 0;
			cmdBfr		= dataBfr;
			
//j1GFX_SetTextRowCol((j1GFX_CTRL *) __pC->deviceCtrl, 6, 0);
//j1Put_Char(__pC, '1');

			// open the ram buffer for xml
			j1XML_Open(j1XML_IOMODE_READ_MEM, (uint32) cmdBfr, pktDataSize);
//j1Put_Char(__pC, '2');
			// read the element
			if ((j1XML_Result = j1XML_ReadElement(0, &element, false)) != j1XML_RESULT_OK) { return `$INSTANCE_NAME`_j1UBL_ERR_CMD; }
//j1Put_Char(__pC, '3');
			if (element.eType != j1XML_ETYPE_EMPTY) { return `$INSTANCE_NAME`_j1UBL_ERR_CMD; }
//j1Put_Char(__pC, '4');
			// parse the element
			if ((j1XML_Result = j1XML_ParseElement(&element, j1UBL_XML_eTbl_size, j1UBL_XML_eTbl, &depth, j1VSIZEOF(eStack), eStack, false)) != j1XML_RESULT_OK)
			{
//j1Put_String(__pC, j1XML_ErrorDecode(j1XML_Result), j1Put_PRESPC);
				return `$INSTANCE_NAME`_j1UBL_ERR_CMD;
			}
//j1Put_Char(__pC, '5');
			// validate the element
			if ((j1XML_Result = j1UBL_XML_Validate(&element, &tokenXXX, depth, eStack)) != j1XML_RESULT_OK) { return `$INSTANCE_NAME`_j1UBL_ERR_CMD; }
//j1Put_Char(__pC, '6');
			CyEEPROM_Start();
			CySetTemp();
			CyDelay(1);
			
			eeRowNum	= 0x40 * (CY_EEPROM_SIZEOF_ARRAY / CY_EEPROM_SIZEOF_ROW);
			
//j1GFX_SetTextRowCol((j1GFX_CTRL *) __pC->deviceCtrl, 6, 0);
//j1Put_Hex16(__pC, pktDataSize, j1Put_PRESPC);
//j1Put_Field(__pC, (char *) cmdBfr, pktDataSize, j1Put_PRESPC);
//j1Put_Hex16(__pC, eeRowNum, j1Put_PRESPC);
//j1Put_Hex8 (__pC, (CY_EEPROM_SIZEOF_ARRAY / CY_EEPROM_SIZEOF_ROW), j1Put_PRESPC);

			rowIndex = 0;
			
			while (pktDataSize)
			{
				memset(eeBfr, 0, sizeof(eeBfr));
				for (rowIndex = 0; rowIndex < CY_EEPROM_SIZEOF_ROW; rowIndex++)
				{
					if (pktDataSize == 0) break;
					eeBfr[rowIndex] = *cmdBfr++;
					pktDataSize--;
//j1Put_Char(__pC, '.');					
				}
				
				// write the row
//j1Put_Char(__pC, '|');
				cyret = CyWriteRowFull(eeRowNum / (CY_EEPROM_SIZEOF_ARRAY / CY_EEPROM_SIZEOF_ROW),
									   eeRowNum % (CY_EEPROM_SIZEOF_ARRAY / CY_EEPROM_SIZEOF_ROW),
									   eeBfr, CY_EEPROM_SIZEOF_ROW);
//j1Put_Hex8 (__pC, cyret, 0);
				if (cyret != CYRET_SUCCESS) return cyret;
//j1Put_Char(__pC, '+');
				eeRowNum++;
			}
			
			if (rowIndex == CY_EEPROM_SIZEOF_ROW)
			{
				memset(eeBfr, 0, sizeof(eeBfr));
				// write the row
				cyret = CyWriteRowFull(eeRowNum / (CY_EEPROM_SIZEOF_ARRAY / CY_EEPROM_SIZEOF_ROW),
									   eeRowNum % (CY_EEPROM_SIZEOF_ARRAY / CY_EEPROM_SIZEOF_ROW),
									   eeBfr, CY_EEPROM_SIZEOF_ROW);
				if (cyret != CYRET_SUCCESS) return cyret;
			}
			
			return CYRET_SUCCESS;
		}
		break;
		
	//--------------------------------------------------------
	// ext_console
	//--------------------------------------------------------
#if `$INSTANCE_NAME`_PARAM_J1CONSOLE_ENABLED
	case 0xec:
#if `$INSTANCE_NAME`_PARAM_HY28B_ENABLED
//		j1GFX_SetTextRowCol(gC, 12, 0);
//		j1Put_Hex32(__pC, wanker++, j1Put_PSTSPC);
//		j1Put_Hex16(__pC, pktDataSize, j1Put_PSTSPC);
#endif
		
		if (pktDataSize)
		{
			j1Console_QueueRx(&pktBfr[`$INSTANCE_NAME`_j1UBL_DATA_ADDR], pktDataSize);
		}
		
		j1Console_DeQueueTx(&pktBfr[`$INSTANCE_NAME`_j1UBL_DATA_ADDR], 54, rspDataSize);
		return CYRET_SUCCESS;
		
		break;
#endif

	//--------------------------------------------------------
	// ext_reboot
	//--------------------------------------------------------
	case 0xef:
		CySoftwareReset();
		break;
	}
	
	return `$INSTANCE_NAME`_j1UBL_ERR_CMD;
}

	#endif	// (`$INSTANCE_NAME`_PARAM_J1UBL_ENABLED)
#endif	// defined(`$INSTANCE_NAME`_COMM_XXX)

//---------------------------------------------------------------------
//
//	Service_ETH0_Rx() - service the eth0 controller receive buffer
//
//---------------------------------------------------------------------

#if defined(`$INSTANCE_NAME`_COMM_XXX)
#if `$INSTANCE_NAME`_PARAM_ETH_ENABLED
void `$INSTANCE_NAME`_Service_ETH0_Rx()
{
	`$INSTANCE_NAME`_ETH0_PREAMBLE		preamble;
	`$INSTANCE_NAME`_ETH0_ARP_PACKET		arpPacket;
	`$INSTANCE_NAME`_ETH0_IP_HEADER		ipHdr;
	`$INSTANCE_NAME`_ETH0_UDP_HEADER		udpHdr;
	`$INSTANCE_NAME`_ETH0_ICMP_HEADER	icmpHdr;
//	uint16				regRead;
	
//	j1GFX_SetTextRowCol(&HY28B_j1GFX_Ctrl, 6, 0);
//	j1Put_Hex16(pC, ++loopCnt, 0);
	
	if (!`$INSTANCE_NAME`_ETH0_MACGetHeader(&preamble)) return;
	
//	j1GFX_SetTextRowCol(&HY28B_j1GFX_Ctrl, 7, 0);
//	j1Put_Hex16(pC, ++pktCnt, 0);
//	j1Put_Hex16(pC, preamble.Type.Val, j1Put_PRESPC);
	
	switch (preamble.Type.Val)
	{
	case `$INSTANCE_NAME`_ETH0_TYPE_ARP:
//		j1GFX_SetTextRowCol(&HY28B_j1GFX_Ctrl, 8, 0);
//		j1Put_Hex16(pC, ++arpCnt, 0);
		`$INSTANCE_NAME`_ETH0_MACGetArray((BYTE *) &arpPacket, sizeof(arpPacket));
		
		// if request, if not from us, if for our ip ... then reply
		if (arpPacket.Operation == `$INSTANCE_NAME`_ETH0_SWAP_WORD(`$INSTANCE_NAME`_ETH0_ARP_REQUEST))
		 if (!`$INSTANCE_NAME`_ETH0_CMP_MAC(arpPacket.SenderMACAddr, `$INSTANCE_NAME`_ETH0_mac_addr))
		  if (`$INSTANCE_NAME`_ETH0_CMP_IPV4(arpPacket.TargetIPAddr, `$INSTANCE_NAME`_ETH0_ipv4_addr))
		{
			`$INSTANCE_NAME`_ETH0_ARPReply(&preamble, &arpPacket);
		}
		break;
		
	case `$INSTANCE_NAME`_ETH0_TYPE_IP:
		// fetch the IP packet header
		`$INSTANCE_NAME`_ETH0_MACGetArray((BYTE *) &ipHdr, sizeof(ipHdr));
		
		switch (ipHdr.Protocol)
		{
		case `$INSTANCE_NAME`_ETH0_IP_ICMP:
//			j1GFX_SetTextRowCol(&HY28B_j1GFX_Ctrl, 8, 5);
//			j1Put_Hex16(pC, ++icmpCnt, 0);
//			j1Put_Hex32(pC, eth0_ipAddr.dwIP     , j1Put_PRESPC);
//			j1Put_Hex32(pC, ipHdr.DestIPAddr.dwIP, j1Put_PRESPC);
			
			// test the target IP address against ours
			// is this for us?
			if (`$INSTANCE_NAME`_ETH0_CMP_IPV4(`$INSTANCE_NAME`_ETH0_ipv4_addr, ipHdr.DestIPAddr))
			{
//				j1Put_Char(pC, '+');
				`$INSTANCE_NAME`_ETH0_MACGetArray((BYTE *) &icmpHdr, sizeof(icmpHdr));
				
//				j1Put_Char(pC, '-');
				if (icmpHdr.Type == `$INSTANCE_NAME`_ETH0_ICMP_ECHO)
				{
//					j1Put_Char(pC, '+');
					`$INSTANCE_NAME`_ETH0_ICMPEchoReply(&preamble, &ipHdr, &icmpHdr);
				}
			}
			break;
			
		case `$INSTANCE_NAME`_ETH0_IP_UDP:
			// fetch the UDP packet header
			`$INSTANCE_NAME`_ETH0_MACGetArray((BYTE *) &udpHdr, sizeof(udpHdr));
			
			switch (`$INSTANCE_NAME`_ETH0_SWAP_WORD(udpHdr.Dest_Port))
			{
			default:
				break;
			}
		
		default:
			break;
		}
		
	default:
		break;
	}
	
	`$INSTANCE_NAME`_ETH0_MACDiscardRx();		// skip frame
}
#endif	// `$INSTANCE_NAME`_PARAM_ETH_ENABLED
#endif	// defined(`$INSTANCE_NAME`_COMM_XXX)

