//=====================================================================
//
//	`$INSTANCE_NAME`.h - j1UBL project design defs
//
//	version 1.2 - 16 apr 2015
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#if !defined(`$INSTANCE_NAME`_H)
#define `$INSTANCE_NAME`_H
	
//#include <project.h>

#define	`$INSTANCE_NAME`_PARAM_BL_SELECT				(`$PD_BL_SELECT`u)
#define	`$INSTANCE_NAME`_PARAM_BL_SELECT_CYBL			(1u)
#define	`$INSTANCE_NAME`_PARAM_BL_SELECT_J1UBL			(2u)
#define	`$INSTANCE_NAME`_PARAM_J1UBL_ENABLED			(`$PD_J1UBL_ENABLED`u)
#define	`$INSTANCE_NAME`_PARAM_SD_ENABLED				(`$PD_SD_ENABLED`u)
#define	`$INSTANCE_NAME`_PARAM_SF_ENABLED				(`$PD_SF_ENABLED`u)
#define	`$INSTANCE_NAME`_PARAM_ETH_ENABLED				(`$PD_ETH_ENABLED`u)
#define	`$INSTANCE_NAME`_PARAM_USB_ENABLED				(`$PD_USB_ENABLED`u)
#define `$INSTANCE_NAME`_PARAM_HY28B_ENABLED			(`$PD_HY28B_ENABLED`u)
#define `$INSTANCE_NAME`_PARAM_HY28B_BL_ENABLED			(`$PD_HY28B_BL_ENABLED`u)
#define `$INSTANCE_NAME`_PARAM_HY28B_LCD_PAR_MODE		(`$PD_HY28B_LCD_PAR_MODE`u)
#define `$INSTANCE_NAME`_PARAM_HY28B_LCD_SPI_MODE		(`$PD_HY28B_LCD_SPI_MODE`u)
#define `$INSTANCE_NAME`_PARAM_HY28B_TOUCH_SPI_ENABLE	(`$PD_HY28B_TOUCH_SPI_ENABLE`u)
#define `$INSTANCE_NAME`_PARAM_HY28B_TOUCH_SPI_SHARED	(`$PD_HY28B_TOUCH_SPI_SHARED`u)
#define `$INSTANCE_NAME`_PARAM_HB1_ENABLED				(`$PD_HB1_ENABLED`u)
#define `$INSTANCE_NAME`_PARAM_HB2_ENABLED				(`$PD_HB2_ENABLED`u)
#define	`$INSTANCE_NAME`_PARAM_DEVICE_NAME				"`$PD_DEVICE_NAME`"
#define `$INSTANCE_NAME`_PARAM_J1CONSOLE_ENABLED		(`$PD_J1CONSOLE_ENABLED`u)
#define `$INSTANCE_NAME`_PARAM_UART_ENABLED				(`$PD_UART_ENABLED`u)
#define	`$INSTANCE_NAME`_PARAM_ARTNET_OEM_CODE			(`$PD_ARTNET_OEM_CODE`u)
#define	`$INSTANCE_NAME`_PARAM_XP_ENABLED				(`$PD_XP_ENABLED`u)

//#include "main.h"

#if defined(CYDEV_BOOTLOADER_IO_COMP)

	#if (`$INSTANCE_NAME`_PARAM_BL_SELECT == `$INSTANCE_NAME`_PARAM_BL_SELECT_CYBL)
		#if ((CYDEV_BOOTLOADER_IO_COMP == CyBtldr_Custom_Interface) && `$INSTANCE_NAME`_PARAM_USB_ENABLED)
			#define CyBtldrCommStart        `$INSTANCE_NAME`_USBFS_CyBtldrCommStart
			#define CyBtldrCommStop         `$INSTANCE_NAME`_USBFS_CyBtldrCommStop
			#define CyBtldrCommReset        `$INSTANCE_NAME`_USBFS_CyBtldrCommReset
			#define CyBtldrCommWrite        `$INSTANCE_NAME`_USBFS_CyBtldrCommWrite
			#define CyBtldrCommRead         `$INSTANCE_NAME`_USBFS_CyBtldrCommRead
		#endif	// (CYDEV_BOOTLOADER_IO_COMP == CyBtldr_Custom_Interface && `$INSTANCE_NAME`_PARAM_USB_ENABLED)
	#endif	// (`$INSTANCE_NAME`_PARAM_BL_SELECT == `$INSTANCE_NAME`_PARAM_BL_SELECT_CYBL)	

	#if (`$INSTANCE_NAME`_PARAM_BL_SELECT == `$INSTANCE_NAME`_PARAM_BL_SELECT_J1UBL)
		#define	`$INSTANCE_NAME`_COMM_XXX
		#define CyBtldrCommStart        `$INSTANCE_NAME`_CommStart
		#define CyBtldrCommStop         `$INSTANCE_NAME`_CommStop
		#define CyBtldrCommReset        `$INSTANCE_NAME`_CommReset
		#define CyBtldrCommWrite        `$INSTANCE_NAME`_CommWrite
		#define CyBtldrCommRead         `$INSTANCE_NAME`_CommRead
		#define	CyBtldrCommCmd			`$INSTANCE_NAME`_CommCmd
		
	    extern void `$INSTANCE_NAME`_CommStart(void);
	    extern void `$INSTANCE_NAME`_CommStop (void);
    	extern void `$INSTANCE_NAME`_CommReset(void);
    	extern cystatus `$INSTANCE_NAME`_CommWrite(uint8* buffer, uint16 size, uint16* count, uint8 timeOut);
    	extern cystatus `$INSTANCE_NAME`_CommRead (uint8* buffer, uint16 size, uint16* count, uint8 timeOut);
		
	    extern uint8 `$INSTANCE_NAME`_CommCmd(uint8* pktBfr, uint16 pktDataSize, uint8* dataBfr, uint16 dataOffset, uint16 *rspDataSize);
		
		typedef enum
		{
			`$INSTANCE_NAME`_COMM_MODE_UNKNOWN
		#if `$INSTANCE_NAME`_PARAM_ETH_ENABLED
			,`$INSTANCE_NAME`_COMM_MODE_ETH
		#endif
		#if `$INSTANCE_NAME`_PARAM_USB_ENABLED
			,`$INSTANCE_NAME`_COMM_MODE_USB
		#endif
		#if `$INSTANCE_NAME`_PARAM_UART_ENABLED
			,`$INSTANCE_NAME`_COMM_MODE_UART
		#endif
		} `$INSTANCE_NAME`_COMM_MODE;
		
		#if !defined(j1THIS_IS_MAIN_APPLICATION)
			extern
		#endif
			`$INSTANCE_NAME`_COMM_MODE	`$INSTANCE_NAME`_comm_mode;

	#endif	// (`$INSTANCE_NAME`_PARAM_BL_SELECT == `$INSTANCE_NAME`_PARAM_BL_SELECT_J1UBL)	

#endif	// defined(CYDEV_BOOTLOADER_IO_COMP)

#endif	// !defined(`$INSTANCE_NAME`_H)
