//=====================================================================
//
//	j1UBL_XML.h - defs file for j1UBL XML
//
//=====================================================================

//=====================================================================
//
// Copyright (c) 2015 Joshua 1 Systems Inc. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without modification, are
// permitted provided that the following conditions are met:
//
//    1. Redistributions of source code must retain the above copyright notice, this list of
//       conditions and the following disclaimer.
//
//    2. Redistributions in binary form must reproduce the above copyright notice, this list
//       of conditions and the following disclaimer in the documentation and/or other materials
//       provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY JOSHUA 1 SYSTEMS INC. "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
// ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// The views and conclusions contained in the software and documentation are those of the
// authors and should not be interpreted as representing official policies, either expressed
// or implied, of Joshua 1 Systems Inc.
//
//=====================================================================

#if !defined(`$INSTANCE_NAME`_j1UBL_XML_H_)
#define `$INSTANCE_NAME`_j1UBL_XML_H_

#include <project.h>
//#include "`$INSTANCE_NAME`_main.h"
	
#define	`$INSTANCE_NAME`_PARAM_ETH_ENABLED		`$j1UBL_XML_ETH_ENABLED`
#define	`$INSTANCE_NAME`_PARAM_XP_ENABLED		`$j1UBL_XML_XP_ENABLED`
#define	`$INSTANCE_NAME`_PARAM_HY28B_ENABLED	`$j1UBL_XML_HY28B_ENABLED`
	
typedef	enum
{
	j1UBL_XML_ATTR_HOST = 1,
#if !`$INSTANCE_NAME`_PARAM_ETH_ENABLED
	j1UBL_XML_ATTR_MAC,
#else
	j1UBL_XML_ATTR_AN,
	j1UBL_XML_ATTR_IP,
	j1UBL_XML_ATTR_NM,
	j1UBL_XML_ATTR_GW,
	j1UBL_XML_ATTR_DNS1,
	j1UBL_XML_ATTR_DNS2,
#endif
	j1UBL_XML_ATTR_PWD,
#if `$INSTANCE_NAME`_PARAM_XP_ENABLED
	j1UBL_XML_ATTR_XP,
#endif
#if `$INSTANCE_NAME`_PARAM_HY28B_ENABLED
	j1UBL_XML_ATTR_HY28B,
#endif
} j1UBL_XML_ATTR;

#define	j1UBL_XML_UBL	1

	j1XML_DICT_ATTR_GEN(j1UBL_XML_HOST , j1UBL_XML_ATTR_HOST , "host" , j1XML_DICT_ATYPE_STRING,  0, 16, 0, NULL);
#if !`$INSTANCE_NAME`_PARAM_ETH_ENABLED
	j1XML_DICT_ATTR_GEN(j1UBL_XML_MAC  , j1UBL_XML_ATTR_MAC  , "mac"  , j1XML_DICT_ATYPE_MAC   ,  1, 17, 0, NULL);
#else
	j1XML_DICT_ATTR_GEN(j1UBL_XML_AN   , j1UBL_XML_ATTR_AN   , "an"   , j1XML_DICT_ATYPE_BYTE  ,  1,  2, 0, NULL);
	j1XML_DICT_ATTR_GEN(j1UBL_XML_IP   , j1UBL_XML_ATTR_IP   , "ip"   , j1XML_DICT_ATYPE_IP    ,  1, 15, 0, NULL);
	j1XML_DICT_ATTR_GEN(j1UBL_XML_NM   , j1UBL_XML_ATTR_NM   , "nm"   , j1XML_DICT_ATYPE_IP    ,  1, 15, 0, NULL);
	j1XML_DICT_ATTR_GEN(j1UBL_XML_GW   , j1UBL_XML_ATTR_GW   , "gw"   , j1XML_DICT_ATYPE_IP    ,  1, 15, 0, NULL);
	j1XML_DICT_ATTR_GEN(j1UBL_XML_DNS1 , j1UBL_XML_ATTR_DNS1 , "dns1" , j1XML_DICT_ATYPE_IP    ,  1, 15, 0, NULL);
	j1XML_DICT_ATTR_GEN(j1UBL_XML_DNS2 , j1UBL_XML_ATTR_DNS2 , "dns2" , j1XML_DICT_ATYPE_IP    ,  1, 15, 0, NULL);
#endif
	j1XML_DICT_ATTR_GEN(j1UBL_XML_PWD  , j1UBL_XML_ATTR_PWD  , "pwd"  , j1XML_DICT_ATYPE_STRING,  0, 16, 0, NULL);
#if `$INSTANCE_NAME`_PARAM_XP_ENABLED
	j1XML_DICT_ATTR_GEN(j1UBL_XML_XP   , j1UBL_XML_ATTR_XP   , "xp"   , j1XML_DICT_ATYPE_STRING,  0,  8, 0, NULL);
#endif
#if `$INSTANCE_NAME`_PARAM_HY28B_ENABLED
	j1XML_DICT_ATTR_GEN(j1UBL_XML_HY28B, j1UBL_XML_ATTR_HY28B, "hy28b", j1XML_DICT_ATYPE_STRING,  0, 31, 0, NULL);
#endif

#if `$INSTANCE_NAME`_PARAM_HY28B_ENABLED
#if `$INSTANCE_NAME`_PARAM_ETH_ENABLED && `$INSTANCE_NAME`_PARAM_XP_ENABLED
	j1XML_DICT_ATTR10_GEN(j1UBL_XML_ubl_aTbl, j1UBL_XML_HOST, j1UBL_XML_AN, j1UBL_XML_IP, j1UBL_XML_NM, j1UBL_XML_GW, j1UBL_XML_DNS1, j1UBL_XML_DNS2, j1UBL_XML_PWD, j1UBL_XML_XP, j1UBL_XML_HY28B);
#elif `$INSTANCE_NAME`_PARAM_ETH_ENABLED
	j1XML_DICT_ATTR9_GEN(j1UBL_XML_ubl_aTbl, j1UBL_XML_HOST, j1UBL_XML_AN, j1UBL_XML_IP, j1UBL_XML_NM, j1UBL_XML_GW, j1UBL_XML_DNS1, j1UBL_XML_DNS2, j1UBL_XML_PWD, j1UBL_XML_HY28B);
#elif `$INSTANCE_NAME`_PARAM_XP_ENABLED
	j1XML_DICT_ATTR5_GEN(j1UBL_XML_ubl_aTbl, j1UBL_XML_HOST, j1UBL_XML_MAC, j1UBL_XML_PWD, j1UBL_XML_XP, j1UBL_XML_HY28B);
#else
	j1XML_DICT_ATTR4_GEN(j1UBL_XML_ubl_aTbl, j1UBL_XML_HOST, j1UBL_XML_MAC, j1UBL_XML_PWD, j1UBL_XML_HY28B);
#endif

#else
#if `$INSTANCE_NAME`_PARAM_ETH_ENABLED && `$INSTANCE_NAME`_PARAM_XP_ENABLED
	j1XML_DICT_ATTR9_GEN(j1UBL_XML_ubl_aTbl, j1UBL_XML_HOST, j1UBL_XML_AN, j1UBL_XML_IP, j1UBL_XML_NM, j1UBL_XML_GW, j1UBL_XML_DNS1, j1UBL_XML_DNS2, j1UBL_XML_PWD, j1UBL_XML_XP);
#elif `$INSTANCE_NAME`_PARAM_ETH_ENABLED
	j1XML_DICT_ATTR8_GEN(j1UBL_XML_ubl_aTbl, j1UBL_XML_HOST, j1UBL_XML_AN, j1UBL_XML_IP, j1UBL_XML_NM, j1UBL_XML_GW, j1UBL_XML_DNS1, j1UBL_XML_DNS2, j1UBL_XML_PWD);
#elif `$INSTANCE_NAME`_PARAM_XP_ENABLED
	j1XML_DICT_ATTR4_GEN(j1UBL_XML_ubl_aTbl, j1UBL_XML_HOST, j1UBL_XML_MAC, j1UBL_XML_PWD, j1UBL_XML_XP);
#else
	j1XML_DICT_ATTR3_GEN(j1UBL_XML_ubl_aTbl, j1UBL_XML_HOST, j1UBL_XML_MAC, j1UBL_XML_PWD);
#endif
#endif

	j1XML_DICT_ELEM_GEN(j1UBL_XML_ubl, j1UBL_XML_UBL, "ubl", j1VSIZEOF(j1UBL_XML_ubl_aTbl), j1UBL_XML_ubl_aTbl);

#ifdef j1THIS_IS_MAIN_APPLICATION
	const j1XML_DICT_ELEM const * const j1UBL_XML_eTbl[] = { &j1UBL_XML_ubl };
	const int	const j1UBL_XML_eTbl_size = j1VSIZEOF(j1UBL_XML_eTbl);
#else
	extern j1XML_DICT_ELEM const * const j1UBL_XML_eTbl[];
	extern int	const j1UBL_XML_eTbl_size;
#endif

//---------------------------------------------------------------------
//
//	Tokenized structures
//
//		the layout of structures that could represent ALL elements
//		and attributes. they may be used by the decode block but
//		in the tokenized data stream they are minimalized to the cmd
//		token (byte) followed by the attr flags (byte). the exception
//		is that the 'p' and 's' elements have two tokens each: one
//		with an attr flags and one without. for some elements the high
//		order bit of the attr flags can reflect addition attr 'x' bytes
//		to follow.
//
//---------------------------------------------------------------------

typedef enum
{
	j1UBL_TOKEN_ELEM_UBL = 1,
} j1UBL_TOKEN_ELEM;

typedef enum
{
	j1UBL_TOKEN_ETYP_START = 0,
	j1UBL_TOKEN_ETYP_STOP,
	j1UBL_TOKEN_ETYP_EMPTY,
	j1UBL_TOKEN_ETYP_EOF
} j1UBL_TOKEN_ETYP;

typedef union _j1UBL_TOKEN
{
	uint8	token;

	struct
	{
		uint8	elem:6;		// CONFIG_TOKEN_ELEM
		uint8	etyp:2;		// CONFIG_TOKEN_ETYP
	} bits;

} j1UBL_TOKEN;

//-------------------------
// j1UBL
//-------------------------

typedef struct _j1UBL_TOKEN_j1UBL
{
	j1UBL_TOKEN	token;		// the token

	union
	{
		uint8	attr;
		struct
		{
			uint8	host:1;			// host
			uint8	mac:1;			// mac
			uint8	an:1;			// an
			uint8	ip:1;			// ip
			uint8	nm:1;			// nm
			uint8	gw:1;			// gw
			uint8	dns1:1;			// dns1
			uint8	dns2:1;			// dns2
		} bits;
	} attr1;

	union
	{
		uint8	attr;
		struct
		{
			uint8	pwd:1;			// pwd
			uint8	xp:1;			// xp
			uint8	hy28b:1;		// hy28b
			uint8	attr23:1;		//
			uint8	attr24:1;		//
			uint8	attr25:1;		//
			uint8	attr26:1;		//
			uint8	attr27:1;		//
		} bits;
	} attr2;

	char		host[17];		// host
#if !`$INSTANCE_NAME`_PARAM_ETH_ENABLED
//	IP_MAC		mac;			// mac
	uint32		mac;			// mac
#else
	uint8		an;				// an
	IP_ADDR		ip;				// ip
	IP_ADDR		nm;				// nm
	IP_ADDR		gw;				// gw
	IP_ADDR		dns1;			// dns1
	IP_ADDR		dns2;			// dns2
#endif
	
	char		pwd[17];		// pwd
#if `$INSTANCE_NAME`_PARAM_XP_ENABLED
	char		xp[9];			// xp
#endif
#if `$INSTANCE_NAME`_PARAM_HY28B_ENABLED
	char		hy28b[32];		// hy28b
#endif

} j1UBL_TOKEN_UBL;

//---------------------------------------------------------------------
//
//	all of the token structs in one union
//
//---------------------------------------------------------------------

typedef union _j1UBL_TOKEN_XXX
{
	j1UBL_TOKEN	token;

	j1UBL_TOKEN_UBL	j1UBL;
} j1UBL_TOKEN_XXX;

//---------------------------------------------------------------------
//
//	j1UBL_XML data area
//
//---------------------------------------------------------------------

typedef struct _j1UBL_XML
{
	struct
	{
		bool	tokensValid;	// token memory valid
		char	msgBfr[256];	// last compiler message

	} Compiler;

} j1UBL_XML;

//GLOBALQUALIFY	UBLXML	ublXML;

//---------------------------------------------------------------------
//
//	j1UBL_XML_COMPILE_XXX enumerators
//
//---------------------------------------------------------------------

typedef enum
{
	j1UBL_XML_COMPILE_CMD_INIT = 0,
	j1UBL_XML_COMPILE_CMD_NEXT,
	j1UBL_XML_COMPILE_CMD_EOF
} j1UBL_XML_COMPILE_CMD;

typedef enum
{
	j1UBL_XML_COMPILER_RESULT_BAD_CMD = j1XML_RESULT__MAXVALUE__,
	j1UBL_XML_COMPILER_RESULT_BAD_DEPTH
} j1UBL_XML_COMPILER_RESULT;


void j1UBL_XML_Init();

j1XML_RESULT	j1UBL_XML_Validate(j1XML_ELEMENT *element, j1UBL_TOKEN_XXX *tokenXXX, int depth, uint16 *eStack);
j1XML_RESULT	j1UBL_XML_EraseXML();
j1XML_RESULT	j1UBL_XML_WriteXML(j1UBL_TOKEN_XXX *tokenXXX);

#endif
